#include "stdafx.h"
#include "Windowsx.h"

#include <CommCtrl.h>
#include "stdio.h"
#include "ControlIT.h"


#if !defined MSFTEDIT_CLASS
#define MSFTEDIT_CLASS L"RICHEDIT50W"
#endif



//****************************** BASE CLASS
// Constructor
ControlIT::ControlIT()
{
	 font = CreateFont(-14, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_DONTCARE, L"Courier New");
	 fontLabel = CreateFont(-14, 0, 0, 0, FW_NORMAL, 0, TRUE, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_DONTCARE, L"Ariel");
	 fontButton = CreateFont(-14, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_DONTCARE, L"Ariel");
	 fontTitle = CreateFont(-16, 0, 0, 0, FW_BOLD, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_DONTCARE, L"Ariel");

	 controlCount = 0;
	 paramCount = 0;
	 indexCount = 0;

}

int ControlIT::MakeControl(HWND hWnd,int type, TCHAR * labeltext,int *initValue, int controlID,double * initDvalue,int flag)
{


	int posX, posY;
	long eflag;

	//HBRUSH brush = CreateSolidBrush(BK_COLOR);
	// WATCHOUT - this got duplicated in the label section, needed to make delete work 
	ctrlValues[indexCount] = initValue;
	ctrlDoubles[indexCount] = initDvalue;
	ctrlIDs[indexCount] = controlID;
	ctrlFlags[indexCount] = flag;


	ctrlType[indexCount]= type;

	switch (type)
	{
	case CT_BUTTON:
		if (flag == FL_UPDATEBTN)
		{
			posX = LEFT_EDGE + P_M_WIDTH + P_HORZ_SPACE;;
			posY = paramCount *(P_M_HEIGHT + P_VERT_SPACE) + P_TOP_EDGE;
		}
		else
		{

			posX = controlCount % NUM_B_COLUMNS;
			posY = controlCount / NUM_B_COLUMNS;
			posX = posX *(B_WIDTH + B_HORZ_SPACE) + LEFT_EDGE;
			posY = posY*(B_HEIGHT + B_VERT_SPACE) + B_TOP_EDGE;
		}
	

		ctrlHWND[indexCount]= CreateWindow( 
			L"BUTTON",  // Predefined class; Unicode assumed 
			labeltext,      // Button text 
			WS_TABSTOP | WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,  // Styles 
			posX,         // x position 
			posY,         // y position 
			B_WIDTH,        // Button width
			B_HEIGHT,        // Button height
			hWnd,     // Parent window
			(HMENU)controlID,       // No menu.
			(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);      // Pointer not needed.

		SendMessage(ctrlHWND[indexCount], WM_SETFONT, (WPARAM)fontButton, MAKELPARAM(true, 0));
		controlCount++;
		indexCount++;
		break;

	case CT_EDITBOX:
		ctrlType[indexCount] = CT_STATIC;  //funky I know

		posX = paramCount % NUM_P_COLUMNS;
		posY = paramCount / NUM_P_COLUMNS;
		posX = posX *(P_M_WIDTH + P_HORZ_SPACE+P_E_WIDTH+P_HORZ_SPACE) + LEFT_EDGE;
		posY = posY *(P_M_HEIGHT + P_VERT_SPACE)+P_TOP_EDGE;

		if (flag == FL_DOUBLE)
		{
			//convert to double string
			swprintf_s(sszText, MAX_LOADSTRING, L"%1.3f", *initDvalue);
		}
		else
		{
			_itow_s(*initValue, sszText, 10);
		}

		eflag = ES_NUMBER;
		ctrlIDs[indexCount] = 0;
		ctrlHWND[indexCount] = CreateWindow(
			L"static",  // Predefined class; Unicode assumed 
			labeltext,      // Button text 
			WS_TABSTOP | WS_VISIBLE | WS_CHILD ,  // Styles 
			posX,         // x position 
			posY,         // y position 
			P_M_WIDTH,        // Button width
			P_M_HEIGHT,        // Button height
			hWnd,     // Parent window
			(HMENU)controlID,       // No menu.
			(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);      // Pointer not needed.
		//SendMessage(ctrlLabel_HWND[indexCount], WM_SETFONT, (WPARAM)fontLabel, MAKELPARAM(true, 0));

		//SetClassLongPtr(ctrlLabel_HWND[indexCount], GCLP_HBRBACKGROUND, (LONG)brush);
		indexCount++;



		ctrlValues[indexCount] = initValue;
		ctrlDoubles[indexCount] = initDvalue;
		ctrlIDs[indexCount] = controlID;
		ctrlFlags[indexCount] = flag;
		ctrlType[indexCount] = type;


		posX = paramCount % NUM_P_COLUMNS;
		posY = paramCount / NUM_P_COLUMNS;
		posX = posX *(P_M_WIDTH + P_HORZ_SPACE + P_E_WIDTH + P_HORZ_SPACE) + LEFT_EDGE + P_M_WIDTH + P_HORZ_SPACE;
		posY = posY *(P_M_HEIGHT + P_VERT_SPACE) + P_TOP_EDGE;


		ctrlHWND[indexCount] = CreateWindow( 
			L"EDIT",  // Predefined class; Unicode assumed 
			sszText,      // Button text 
			WS_TABSTOP | WS_VISIBLE | WS_CHILD | WS_BORDER | ES_CENTER | eflag,  // Styles 
			posX,         // x position 
			posY,         // y position 
			P_E_WIDTH,        // Button width
			P_E_HEIGHT,        // Button height
			hWnd,     // Parent window
			(HMENU)controlID,       // No menu.
			(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);      // Pointer not needed.

		paramCount++;
		indexCount++;
		break;

	case CT_LABEL:
		    
			//controlCount += NUM_B_COLUMNS;
		    controlCount = controlCount + (NUM_B_COLUMNS - (controlCount % NUM_B_COLUMNS));
			posX = controlCount % NUM_B_COLUMNS;
			posY = controlCount / NUM_B_COLUMNS;
			posX = posX *(P_M_WIDTH + B_HORZ_SPACE) + LEFT_EDGE;
			posY = posY*(B_HEIGHT + B_VERT_SPACE) + B_TOP_EDGE;
		


			ctrlHWND[indexCount] = CreateWindow(
				L"static",  // Predefined class; Unicode assumed 
				labeltext,      // Button text 
				WS_TABSTOP | WS_VISIBLE | WS_CHILD,  // Styles 
				posX,         // x position 
				posY,         // y position 
				P_M_WIDTH + P_M_WIDTH,        // Button width
				P_M_HEIGHT,        // Button height
				hWnd,     // Parent window
				(HMENU)controlID,       // No menu.
				(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
				NULL);      // Pointer not needed.

		SendMessage(ctrlHWND[indexCount], WM_SETFONT, (WPARAM)fontLabel, MAKELPARAM(true, 0));
		controlCount += NUM_B_COLUMNS;
		indexCount++;
		break;

	case CT_CHECKBOX:


		posX = paramCount % NUM_P_COLUMNS;
		posY = paramCount / NUM_P_COLUMNS;
		posX = posX *(P_M_WIDTH + P_HORZ_SPACE + P_E_WIDTH + P_HORZ_SPACE) + LEFT_EDGE;
		posY = posY *(P_M_HEIGHT + P_VERT_SPACE) + P_TOP_EDGE;

		ctrlHWND[indexCount] = CreateWindow(
			L"BUTTON",  // Predefined class; Unicode assumed 
			labeltext,      // Button text 
			WS_TABSTOP | WS_VISIBLE | WS_CHILD | BS_AUTOCHECKBOX,  // Styles 
			posX,         // x position 
			posY,         // y position 
			P_M_WIDTH+P_E_WIDTH,        // Button width
			P_M_HEIGHT,        // Button height
			hWnd,     // Parent window
			(HMENU)controlID,       // No menu.
			(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);      // Pointer not needed.
						//SendMessage(ctrlLabel_HWND[indexCount], WM_SETFONT, (WPARAM)fontLabel, MAKELPARAM(true, 0));

						//SetClassLongPtr(ctrlLabel_HWND[indexCount], GCLP_HBRBACKGROUND, (LONG)brush);
		indexCount++;
		paramCount++;
		break;

	case CT_COMBOBOX:


		posX = paramCount % NUM_P_COLUMNS;
		posY = paramCount / NUM_P_COLUMNS;
		posX = posX *(P_M_WIDTH + P_HORZ_SPACE + P_E_WIDTH + P_HORZ_SPACE) + LEFT_EDGE;
		posY = posY *(P_M_HEIGHT + P_VERT_SPACE) + P_TOP_EDGE;

		ctrlHWND[indexCount] = CreateWindow(
			WC_COMBOBOX,  // Predefined class; Unicode assumed 
			TEXT(""),      // Button text 
			CBS_DROPDOWN | CBS_HASSTRINGS | WS_CHILD | WS_OVERLAPPED | WS_VISIBLE,  // Styles 
			posX,         // x position 
			posY,         // y position 
			P_M_WIDTH + P_E_WIDTH,        // Button width
			P_M_COMBOHEIGHT,        // Button height
			hWnd,     // Parent window
			(HMENU)controlID,       // No menu.
			(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);      // Pointer not needed.
						//SendMessage(ctrlLabel_HWND[indexCount], WM_SETFONT, (WPARAM)fontLabel, MAKELPARAM(true, 0));

						//SetClassLongPtr(ctrlLabel_HWND[indexCount], GCLP_HBRBACKGROUND, (LONG)brush);
		indexCount++;
		paramCount++;
		break;


	case CT_LABEL_PARAMS:

		//paramCount += NUM_P_COLUMNS;
		paramCount = paramCount + (NUM_P_COLUMNS - (paramCount % NUM_P_COLUMNS));

		posX = paramCount % NUM_P_COLUMNS;
		posY = paramCount / NUM_P_COLUMNS;

		posX = posX *(P_M_WIDTH + P_HORZ_SPACE + P_E_WIDTH + P_HORZ_SPACE) + LEFT_EDGE;
		posY = posY *(P_M_HEIGHT + P_VERT_SPACE) + P_TOP_EDGE;


		ctrlHWND[indexCount] = CreateWindow(
			L"static",  // Predefined class; Unicode assumed 
			labeltext,      // Button text 
			WS_TABSTOP | WS_VISIBLE | WS_CHILD,  // Styles 
			posX,         // x position 
			posY,         // y position 
			P_M_WIDTH + P_M_WIDTH,        // Button width
			P_M_HEIGHT,        // Button height
			hWnd,     // Parent window
			(HMENU)controlID,       // No menu.
			(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
			NULL);      // Pointer not needed.

		SendMessage(ctrlHWND[indexCount], WM_SETFONT, (WPARAM)fontLabel, MAKELPARAM(true, 0));
		//paramCount++;
		paramCount = paramCount + (NUM_P_COLUMNS - (paramCount % NUM_P_COLUMNS));

		indexCount++;
		break;
	}
	return (indexCount-1);
}

void ControlIT::KillControls()
{
	for (int i = 0; i < indexCount; i++)
	{
		DestroyWindow(ctrlHWND[i]);
	}
	indexCount = 0;
	controlCount = 0; 
	paramCount = 0;
}

void ControlIT::PaintIT(HWND hWnd)
{
#define ID_RUNBUTTON 3 // hack for now fix later

	MakeControl(hWnd, CT_BUTTON, L"RUN", NULL, ID_RUNBUTTON,NULL,0);
	MakeControl(hWnd, CT_BUTTON, L"One Generation", NULL, 1, NULL, 0);
	MakeControl(hWnd, CT_BUTTON, L"Clear", NULL, 2, NULL, 0);
	MakeControl(hWnd, CT_BUTTON, L"Spawn", NULL, 3, NULL, 0);
	//MakeControl(hWnd, CT_BUTTON, L"test ABD", NULL, 4, NULL, 0);
	//MakeControl(hWnd, CT_BUTTON, L"Load", NULL, 5, NULL, 0);
	//MakeControl(hWnd, CT_BUTTON, L"Generation", NULL, 6, NULL, 0);





	//SendMessage(populationPTR->hwndEdit2, WM_SETFONT, (WPARAM)font, MAKELPARAM(true, 0));

	SetFocus(hWnd);

}

void ControlIT::UpdateParams(int startParam)
{
	
	for (int i = startParam; i < indexCount; i++)
	{
		if (ctrlType[i] == CT_EDITBOX)
		{
			if (ctrlFlags[i] == FL_DOUBLE)
			{
				GetWindowText(ctrlHWND[i], sszText, MAX_LEADBYTES);
				if (ctrlDoubles[i] != NULL)
				{
					//*ctrlDoubles[i] = _wtodbl(sszText);
					//cUTF utf(sszText);
					//TCHAR *t = _T("1000.99");
					LPTSTR endPtr;
					double temp;
					*ctrlDoubles[i] = _tcstod(sszText, &endPtr);
					//_atodbl((_CRT_DOUBLE *)ctrlDoubles[i], (char *)utf.get8());
				}
	
			}
			else
			{
				GetWindowText(ctrlHWND[i], sszText, MAX_LOADSTRING);
				if (ctrlValues[i]!=NULL)
					*ctrlValues[i] = _ttoi(sszText);
			}
		}
	}
}

ControlIT::~ControlIT()
{

}


////// Helper Utilities
/// Construct from UTF-16
/// Construct from UTF-16
cUTF::cUTF(const wchar_t * ws)
{
	// store copy of UTF16
	myString16 = (wchar_t *)malloc(wcslen(ws) * 2 + 2);
	wcscpy_s(myString16, wcslen(ws) * 2 + 2, ws);
	// How long will the UTF-8 string be
	int len = WideCharToMultiByte(CP_UTF8, 0,
		ws, wcslen(ws),
		NULL, NULL, NULL, NULL);
	// allocate a buffer
	myString8 = (char *)malloc(len + 1);
	// convert to UTF-8
	WideCharToMultiByte(CP_UTF8, 0,
		ws, wcslen(ws),
		myString8, len, NULL, NULL);
	// null terminate
	*(myString8 + len) = '\0';
}
///  Construct from UTF8
cUTF::cUTF(const char * s)
{
	myString8 = (char *)malloc(strlen(s) + 1);
	strcpy_s(myString8, strlen(s) + 1, s);
	// How long will the UTF-16 string be
	int len = MultiByteToWideChar(CP_UTF8, 0,
		s, strlen(s),
		NULL, NULL);
	// allocate a buffer
	myString16 = (wchar_t *)malloc(len * 2 + 2);
	// convert to UTF-16
	MultiByteToWideChar(CP_UTF8, 0,
		s, strlen(s),
		myString16, len);
	// null terminate
	*(myString16 + len) = L'\0';
}
