#pragma once

#define MAX_LOADSTRING 100

#define MAX_CONTROLS 100
#define CT_BUTTON 1
#define CT_EDITBOX 2
#define CT_STATIC 3
#define CT_LABEL 4
#define CT_LABEL_PARAMS 5
#define CT_CHECKBOX 6
#define CT_COMBOBOX 7

#define FL_DOUBLE 1
#define FL_UPDATEBTN 2

#define B_HEIGHT 30
#define B_WIDTH 114
#define B_HORZ_SPACE 8
#define B_VERT_SPACE 8
#define LEFT_EDGE 15
#define B_TOP_EDGE 400
#define NUM_B_COLUMNS 3
#define NUM_P_COLUMNS 2

#define P_HORZ_SPACE 5
#define P_VERT_SPACE 5
#define P_TOP_EDGE 25

#define P_M_WIDTH 120
#define P_M_HEIGHT 20
#define P_M_COMBOHEIGHT 300

#define P_E_WIDTH 60
#define P_E_HEIGHT 20

// Defining contro IDs
// conventions is
// CONTEXT_NAME_TYPE_NAME
// Current contexts are
//    BASE = owned by the base population class
//    TSP = Traveling Sales Man test
//    NEU = neuron evolver

// Base buttons 2000
#define BASE_BTN_UPDATE 2000
#define BASE_BTN_EVOLVE 2001
#define BASE_BTN_NEWPOP 2002
#define BASE_BTN_ONEGENERATION 2003

// Base Fields 2500
#define BASE_FLD_POPULATION 2500
#define BASE_FLD_CHROMOSOME  2501
#define BASE_FLD_MUTATE 2502

// Traveling buttons 3000
#define TSP_BTN_HEURISTIC 3000
#define TSP_BTN_NEWPATHS 3001
#define TSP_BTN_TOGGLE 3002

// Neuron buttons 4000
#define NEU_BTN_ANIMATE 4000
#define NEU_BTN_INCREMENT 4001
#define NEU_BTN_ANIMATECYCLE 4002
#define NEU_BTN_ANIMATEFULL 4003

// Neuron fields 4500
#define NEU_FLD_COMBO 4500
#define NEU_FLD_NODEZERO 4501
#define NEU_FLD_MAXNODE 4502
#define NEU_FLD_INHIBIT 4503
#define NEU_FLD_NODEONE 4504
#define NEU_FLD_DRAWMODE 4505
#define NEU_FLD_NUMCYCLES 4506
#define NEU_FLD_SLEEPMS 4507
#define NEU_FLD_SCALEFACTOR 4508

#define NEU_FLD_S0 4511
#define NEU_FLD_S1 4512
#define NEU_FLD_S2 4513
#define NEU_FLD_S3 4514
#define NEU_FLD_S4 4515
#define NEU_FLD_S5 4516

#define NEU_FLD_M0 4521
#define NEU_FLD_M1 4522
#define NEU_FLD_M2 4523





class ControlIT
{
private:

public:

	int test1, test2, test3;  //get rid of after testing.
	double testdouble;

	WCHAR sszText[MAX_LOADSTRING];  //temp will fix later
	char charzText[MAX_LOADSTRING];
	HFONT font;
	HFONT fontLabel;
	HFONT fontButton;
	HFONT fontTitle;

	int deviceWidth, deviceHeight;

	int controlCount, paramCount,indexCount;

	HWND ctrlHWND[MAX_CONTROLS];
	//HWND ctrlLabel_HWND[MAX_CONTROLS];
	int  *ctrlValues[MAX_CONTROLS];
	int  ctrlIDs[MAX_CONTROLS];
	double  *ctrlDoubles[MAX_CONTROLS];

	int ctrlType[MAX_CONTROLS];
	int ctrlFlags[MAX_CONTROLS];


	///TEMP FOR TEST AND XFER REMOVE



	HWND hwndButton2;
	HWND hwndButton;

	ControlIT();

	

	virtual void PaintIT(HWND);
	virtual int MakeControl(HWND, int , TCHAR * , int *, int ,double*,int);
	virtual void UpdateParams(int);
	virtual void KillControls();
	~ControlIT();
};

/// Some Helper Utilities
/**

Conversion between UTF-8 and UTF-16 strings.

UTF-8 is used by web pages.  It is a variable byte length encoding
of UNICODE characters which is independant of the byte order in a computer word.

UTF-16 is the native Windows UNICODE encoding.

The class stores two copies of the string, one in each encoding,
so should only exist briefly while conversion is done.

This is a wrapper for the WideCharToMultiByte and MultiByteToWideChar
*/
class cUTF
{
	wchar_t * myString16;       ///&amp;lt; string in UTF-16
	char * myString8;           ///&amp;lt; string in UTF-6
public:
	/// Construct from UTF-16
	cUTF(const wchar_t * ws);
	///  Construct from UTF8
	cUTF(const char * s);
	/// get UTF16 version
	const wchar_t * get16() { return myString16; }
	/// get UTF8 version
	const char * get8() { return myString8; }
	/// free buffers
	~cUTF() { free(myString8); free(myString16); }
};

