#include "stdafx.h"
#include "Neuron.h"
#include "Critter.h"

//****************************** Critter CLASS
// Constructor
Critter::Critter(Neuron *neuronptr)
{
	curBrain = 0;
	numBrains = 0;
	neuronCount = 0;
	chromeCount = 0;
	globalNeuronPTR = neuronptr;

	for (int i = 0; i < MAXBRAINS; i++) { lastX[i] = 0; lastY[i] = 0; }
	for (int i = 0; i < NUM_MUSCLES; i++)
		CritterMuscle[i] = new ExternalMuscle;
	//brainPTR = new Neuron[MAXBRAINS];
}

Neuron * Critter::AddBrain(int population, int totalchrome, double mutate, int numneurons, int width, int height, TCHAR * brainname)
{
	Neuron * retval = NULL;

	if (numBrains < MAXBRAINS)
	{
		brainPTR[numBrains] = new Neuron(population, totalchrome, mutate, numneurons);
		brainPTR[numBrains] ->Init(width, height, brainname);
		retval = brainPTR[numBrains];
		neuronCount += numneurons;
		chromeCount += totalchrome;
		curBrain = numBrains;

		numBrains++;
	}
	return(retval);
}

void Critter::NextBrain()
{
	curBrain++;
	if (curBrain == numBrains)
		curBrain = 0;
}

void Critter::FreeStorage()

{
	for (int i = 0; i < numBrains; i++)
	{
		delete brainPTR[i];
	}
	for (int i = 0; i < NUM_MUSCLES; i++)
		delete CritterMuscle[i];
}

Critter::~Critter()
{

	FreeStorage();

}

void Critter::ClearMuscles()
{
	for (int i = 0; i < NUM_MUSCLES; i++)
		CritterMuscle[i]->ResetMuscle();
}


//********************** Muscle Class
ExternalMuscle::ExternalMuscle()
{
	state = 0;
}

ExternalMuscle::~ExternalMuscle()
{

}

void ExternalMuscle::ResetMuscle()
{
	state = 0;
}

void ExternalMuscle::SetMuscle(int val)
{
	state = val;
}

