#include "stdafx.h"
#include "math.h"
#include "DanFile.h"
#include "Population.h"
#include "Neuron.h"
#include "Evolve.h"
#include "time.h"
#if !defined MSFTEDIT_CLASS
#define MSFTEDIT_CLASS L"RICHEDIT50W"
#endif


//****************************** NEURON CLASS
// Constructor
Neuron::Neuron(int NEWtotalpop, int NEWtotalchrome, double NEWmutate,int NEWneurons) :Population(NEWtotalpop, NEWtotalchrome, NEWmutate, NEWneurons)
{
	//Traveling(NEWtotalpop, NEWtotalchrome):Population(NEWtotalpop, NEWtotalchrome);  //Explicity call base constructor don't know why I have to?
	
	//TotalNeurons = totalchrome/4;
	TotalNeurons = NEWneurons;
	SizeofPool = (TotalNeurons * (TotalNeurons - 1))*2;
	SynapsePool = new synapse[SizeofPool];
	Howfit = new int[NEWtotalpop];
	Tournfit = new int[TOURNAMENTSIZE];
	NeuronState = new int[TotalNeurons];
	tempState = new int[TotalNeurons];

	for (int i = 0; i < NUM_SENSORY; i++)
		Sensory[i] = 0;

	for (int i = 0; i < NUM_MUSCLES; i++)
		Muscle[i] = 0;

	CritterOwner = NULL;
	scaleFactor = 1;
}

void Neuron::Init(int width, int height, TCHAR * brainname)
{

	deviceWidth = width;
	deviceHeight = height;
	_tcscpy_s(name, MAXPATH, brainname);
	Cursor = 0;
	NeuronTypeIndex = 0;
	DrawModeIndex = 0;
	nodeZeroValue = 1;
	nodeOneValue = 0;
	maxNodeValue = 20;
	sleepMS = 250;
	
	NUM_CYCLES = 3;

	inhibitState = TRUE;
	int i, j, index;
	index = 0;
	//for(index = 0; index < SizeofPool; )
	while (index < (SizeofPool- TotalNeurons))
	{
		for (i = 0; i < TotalNeurons; i++)
		{
			for (j = 0; j < TotalNeurons; j++)
			{
				if (i == j)
				{
			 
				}
				else
				{
					SynapsePool[index].start = i;
					SynapsePool[index ].end = j;
					SynapsePool[index].sign = POSITIVE;
					index++;
					SynapsePool[index].start = i;
					SynapsePool[index].end = j;
					SynapsePool[index].sign = NEGATIVE;
					index++;
				}

			}
		}

		//while(SynapsePool[i].start == SynapsePool[i].end)   // make sure we don't point to ourselves
		//{
		//	SynapsePool[i].start = rand() % totalpop;
		//	SynapsePool[i].end = rand() % totalpop;
		//}
	}

	//Create a chromosomes.  Will make it more complex later
	for(i = 0; i < totalpop; i++)
	{
		for(j = 0; j < totalchrome; j++)
		{
			Beings[i][j] = rand() % SizeofPool;  // each being has an index into the Synapse pool array of synapses
		}
	}


	CalcFitness();
}


int Neuron::TournFittest()
{
	int retval;

	retval = 0;
	for (int i = 1; i < TOURNAMENTSIZE; i++)
	{
		if (Howfit[retval] <= Tournfit[i])
			retval = i;
	}

	return retval;
}

void Neuron::CalcOneFit(int i, int j)
{
	Tournfit[i] = Howfit[j];
	//TournDistance[i] = TotalDistance[j];
}
int Neuron::fitnessLookup(int index)
{
	return(Howfit[index]);
}
int Neuron::Fittest()
{
	int retval;

	retval = 0;
	for (int i = 1; i < totalpop; i++)
	{
		if (Howfit[retval] <= Howfit[i])  // add fittness probably simulation call here
			retval = i;
	}

	return retval;
}

void Neuron::TableSearch(int *nodes,int *mask,int op,int x)
{
#define OP_SUM 1
#define OP_ISON 2

	int prerun[4];
	ClearAnimate(x);
	for (int i = 0; i < 4; i++)
	{
			prerun[i] = NeuronState[nodes[i]] = mask[i];
	}

	for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
	{
		NextNeuronState(x);
	}
	switch (op)
	{
	case OP_SUM:
		if (((prerun[0]) + (prerun[1]) + (prerun[2]) + (prerun[3])) == NeuronState[2])
			Howfit[x]++;
		break;

	case OP_ISON:
		if (((prerun[0]==1) || (prerun[1]==1) || (prerun[2]==1) || (prerun[3]==1)) && (NeuronState[2]==1))
			Howfit[x]++;

		if (((prerun[0] == 0) && (prerun[1] == 0) && (prerun[2] == 0) && (prerun[3] == 0)) && (NeuronState[2] == 0))
			Howfit[x]++;
		break;
	}
}

void Neuron::CalcFitness()
{

	//int NUM_CYCLES;
	int blinker; int timer;
	int state2, state2cycle;
	int n0, n1;
	int s0, s1, s2, s3;
	int bonus;
	int flag;
	int testrow[4];
	int mask[4];
	
	// maybe call to the simulator here
	for (int x = 0; x<totalpop; x++)
	{
		ClearAnimate(x);
		Howfit[x] = 0;
		switch (NeuronTypeIndex)
		{

		case 0:					//total on
			//NUM_CYCLES = 4;
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			for (int j = 0; j < TotalNeurons; j++)
				{
					Howfit[x] += NeuronState[j];
				}
								
			break;

		case 1:					// 5 output hold
			n0 = NeuronState[0];
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
				if (NeuronState[TotalNeurons - NUM_MUSCLES] == n0)
					Howfit[x]++;
			}
			break;

		case 2:					// Playground
			//NUM_CYCLES = 5;
			state2 = NeuronState[2];
			timer = 0;
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
				switch (cycles)
				{
				case 0:
					if ((NeuronState[2] == 1)
						&&(NeuronState[3] == 1)&&(NeuronState[4] == 0)&&(NeuronState[5] == 0)) Howfit[x]++;
					break;

				case 1:
					if ((NeuronState[3] == 1)
						&& (NeuronState[2] == 0) && (NeuronState[4] == 1) && (NeuronState[5] == 0)) Howfit[x]++;

					break;
				case 2:
					if ((NeuronState[4] == 1)
						&& (NeuronState[2] == 0) && (NeuronState[3] == 0) && (NeuronState[5] == 1)) Howfit[x]++;

					break;
				case 3:
					if ((NeuronState[5] == 1)
						&& (NeuronState[2] == 0) && (NeuronState[3] == 0) && (NeuronState[6] == 1) && (NeuronState[4] == 0)) Howfit[x]++;

					break;


				}
			}
			break;
		case 3:								// Blinker
			//NUM_CYCLES = 10;
			state2 = NeuronState[2];
			timer = 0;
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
				if (state2 != NeuronState[2])
				{
					Howfit[x]++;
					state2 = NeuronState[2];
				}
			}
	
			break;
		case 4:							// 2 Volt Select  if volt is 2, light up the output
			                            // **** REMEMBER THAT node 1 needs to be 1

			//NUM_CYCLES = 3;
			NeuronState[0] = 3;
			n0 = NeuronState[0];
			NeuronState[1] = 1;
			n1 = NeuronState[1];


			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n0 == 3)  && (NeuronState[2] == 0))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 2;

			n0 = NeuronState[0];
			NeuronState[1] = 1;
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
				NextNeuronState(x);

			if ((n0 == 2) && (NeuronState[2] == 2))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 1;
			n0 = NeuronState[0];
			NeuronState[1] = 1;
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
				NextNeuronState(x);

			if ((n0 == 1) && (NeuronState[2] == 0))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 4;
			n0 = NeuronState[0];
			NeuronState[1] = 1;
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
				NextNeuronState(x);

			if ((n0 == 4) && (NeuronState[2] == 0))
				Howfit[x]++;

			break;

		case 5:							//2 Bit MUX
			//NUM_CYCLES = 3;
			NeuronState[0] = 1;
			NeuronState[1] = 1;
			n0 = NeuronState[0];
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n0 == 1) && (n1 == 1) && (NeuronState[4]==1)&&(NeuronState[3] == 0)&&(NeuronState[2] == 0))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 1;
			NeuronState[1] = 0;
			n0 = NeuronState[0];
			n1 = NeuronState[1];
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
				NextNeuronState(x);

			if ((n0 == 1) && (n1 == 0) && (NeuronState[4] == 0) && (NeuronState[3] == 0) && (NeuronState[2] == 1))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 0;
			NeuronState[1] = 1;
			n0 = NeuronState[0];
			n1 = NeuronState[1];
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
				NextNeuronState(x);

			if ((n0 == 0) && (n1 == 1) && (NeuronState[4] == 0) && (NeuronState[3] == 1) && (NeuronState[2] == 0))
				Howfit[x]++;
			break;


		case 6:							//3 Counter
			//NUM_CYCLES = 3;

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
				switch (cycles)
				{
				case 0:
					if (NeuronState[2] == 1)
						Howfit[x]++;
					break;

				case 1:
					if (NeuronState[2] == 2)
						Howfit[x]++;

					break;
				case 2:
					if (NeuronState[2] == 3)
						Howfit[x]++;

					break;
				}

			}

			break;

		case 7:							// 3 Delay
			flag = FALSE;
			//NUM_CYCLES = 4;
			state2cycle = 0;
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

				if (NeuronState[2] > 0 && flag == FALSE)
				{
					flag = TRUE;
					state2cycle = cycles;
				}
			}
			Howfit[x] = state2cycle;
			Howfit[x] = 3 - abs(3 - Howfit[x]);
			break;

		case 8:              //Muli-input
			//NUM_CYCLES = 3;
			//  run for 0 1
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}

			if ((NeuronState[3] == 1)&&(NeuronState[4] == 0)&&(NeuronState[5] == 0))
			{
				Howfit[x]++;
			}
			// run for  1 0
			ClearAnimate(x);
			NeuronState[0] = 0;
			NeuronState[1] = 1;
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
				NextNeuronState(x);
		
			if ((NeuronState[3] == 0) && (NeuronState[4] == 1) && (NeuronState[5] == 0))
			{
				Howfit[x]++;
			}

			// run for 1 1
			ClearAnimate(x);
			NeuronState[0] = 1;
			NeuronState[1] = 1;
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
				NextNeuronState(x);

			if ((NeuronState[3] == 0) && (NeuronState[4] == 0) && (NeuronState[5] == 1))		
			{
				Howfit[x]++;
			}

			break;

		case 9:			// Voltage Latch
			//NUM_CYCLES = 2;
			ClearAnimate(x);
			NeuronState[0] = 3;
			//NeuronState[2] = 0;
			n0 = NeuronState[0];
			NeuronState[1] = 1;
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n1 == 1) && (NeuronState[2] ==3))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 2;
			//NeuronState[2] = 0;
			n0 = NeuronState[0];
			NeuronState[1] = 1;
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n1 == 1) && (NeuronState[2] == 2))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 1;
			//NeuronState[2] = 0;
			n0 = NeuronState[0];
			NeuronState[1] = 1;
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n1 == 1) && (NeuronState[2] == 1))
				Howfit[x]++;

			
			ClearAnimate(x);
			NeuronState[0] = 4;
			//NeuronState[2] = 0;
			n0 = NeuronState[0];
			NeuronState[1] = 1;
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n1 == 1) && (NeuronState[2] == 4))
				Howfit[x]++;
			
			ClearAnimate(x);
			//NeuronState[2] = 3;
			//NeuronState[0] = 0;
			NeuronState[0] = 1;
			n0 = NeuronState[0];
			NeuronState[1] = 0;
			n1 = NeuronState[1];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n1 == 0) && (NeuronState[2] == 0))
				Howfit[x]++;
			break;

		case 10:							//Sensory input with delay specified by num cycles
			n0 = NeuronState[0];
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if (n0==NeuronState[2])
				Howfit[x]++;


			break;

		case 11:			// 2 volt filter   NOTE NODE 1 NEEDS TO BE SET TO 1 when saving
			ClearAnimate(x);
			NeuronState[0] = 2;
			NeuronState[1] = 1;
			n0 = NeuronState[0];
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n0==2) && (NeuronState[2]==2))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 1;
			NeuronState[1] = 1;
			n0 = NeuronState[0];
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n0 == 1) && (NeuronState[2] == 0))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 3;
			NeuronState[1] = 1;
			n0 = NeuronState[0];
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n0 == 3) && (NeuronState[2] == 0))
				Howfit[x]++;

			ClearAnimate(x);
			NeuronState[0] = 4;
			NeuronState[1] = 1;
			n0 = NeuronState[0];
			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);

			}
			if ((n0 == 4) && (NeuronState[2] == 0))
				Howfit[x]++;
			break;


		case 12:			// 4 sensor Summer  
			testrow[0] = TotalNeurons - NUM_SENSORY;
			testrow[1] = TotalNeurons - NUM_SENSORY+1;
			testrow[2] = TotalNeurons - NUM_SENSORY + 2;
			testrow[3] = TotalNeurons - NUM_SENSORY + 3;
			for (int i = 0; i < 2; i++)
			{
				mask[0] = i; mask[1] = 0; mask[2] = 0; mask[3] = 0;
				TableSearch(testrow, mask, OP_SUM, x);
				mask[0] = i; mask[1] = 0; mask[2] = 0; mask[3] = 1;
				TableSearch(testrow, mask, OP_SUM, x);
				mask[0] = i; mask[1] = 0; mask[2] = 1; mask[3] = 0;
				TableSearch(testrow, mask, OP_SUM, x);
				mask[0] = i; mask[1] = 0; mask[2] = 1; mask[3] = 1;
				TableSearch(testrow, mask, OP_SUM, x);
				mask[0] = i; mask[1] = 1; mask[2] = 0; mask[3] = 0;
				TableSearch(testrow, mask, OP_SUM, x);
				mask[0] = i; mask[1] = 1; mask[2] = 0; mask[3] = 1;
				TableSearch(testrow, mask, OP_SUM, x);
				mask[0] = i; mask[1] = 1; mask[2] = 1; mask[3] = 0;
				TableSearch(testrow, mask, OP_SUM, x);
				mask[0] = i; mask[1] = 1; mask[2] = 1; mask[3] = 1;
				TableSearch(testrow, mask, OP_SUM, x);
			}
			break;

		case 13:			// 1 Pixel Recognizer  -NOTE  NODE 0 MUST BE SET TO 0 - HACK

			testrow[0] = TotalNeurons - NUM_SENSORY;
			testrow[1] = TotalNeurons - NUM_SENSORY + 1;
			testrow[2] = TotalNeurons - NUM_SENSORY + 2;
			testrow[3] = TotalNeurons - NUM_SENSORY + 3;
			for (int i = 0; i < 2; i++)
			{
				mask[0] = i; mask[1] = 0; mask[2] = 0; mask[3] = 0;
				TableSearch(testrow, mask, OP_ISON, x);
				mask[0] = i; mask[1] = 0; mask[2] = 0; mask[3] = 1;
				TableSearch(testrow, mask, OP_ISON, x);
				mask[0] = i; mask[1] = 0; mask[2] = 1; mask[3] = 0;
				TableSearch(testrow, mask, OP_ISON, x);
				mask[0] = i; mask[1] = 0; mask[2] = 1; mask[3] = 1;
				TableSearch(testrow, mask, OP_ISON, x);
				mask[0] = i; mask[1] = 1; mask[2] = 0; mask[3] = 0;
				TableSearch(testrow, mask, OP_ISON, x);
				mask[0] = i; mask[1] = 1; mask[2] = 0; mask[3] = 1;
				TableSearch(testrow, mask, OP_ISON, x);
				mask[0] = i; mask[1] = 1; mask[2] = 1; mask[3] = 0;
				TableSearch(testrow, mask, OP_ISON, x);
				mask[0] = i; mask[1] = 1; mask[2] = 1; mask[3] = 1;
				TableSearch(testrow, mask, OP_ISON, x);
			}

			break;

		case 14:				// Diag Fileter  THIS IS A HOT MESS,  NEEDS A TABLE FUNCTION

			ClearAnimate(x);
			n0 = NeuronState[0] = 2;
			s0 = NeuronState[TotalNeurons - NUM_SENSORY] = 1;
			s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1];
			s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2];
			s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3] = 1;

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			if ((n0==2)&& (s0 ==1) &&(s3 == 1) && (NeuronState[2]==2))
				Howfit[x]++;

			ClearAnimate(x);
			n0 = NeuronState[0] = 2;
			s0 = NeuronState[TotalNeurons - NUM_SENSORY] = 0;
			s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1];
			s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2];
			s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3] = 0;

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			if ((n0 == 2) && (s0 == 0) && (s3 == 0) && (NeuronState[2] == 0))
				Howfit[x]++;

			ClearAnimate(x);
			n0 = NeuronState[0] = 2;
			s0 = NeuronState[TotalNeurons - NUM_SENSORY] ;
			s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1]=1;
			s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2]=1;
			s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3] ;

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			if ((n0 == 2) && (s1 == 1) && (s2 == 1)  && (NeuronState[2] == 2))
				Howfit[x]++;

			ClearAnimate(x);
			n0 = NeuronState[0] = 2;
			s0 = NeuronState[TotalNeurons - NUM_SENSORY];
			s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1]=0;
			s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2]=0;
			s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3] ;

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			if ((n0 == 2) && (s1 == 0) && (s2 == 0) && (NeuronState[2] == 0))
				Howfit[x]++;


			//ClearAnimate(x);
			//n0 = NeuronState[0] = 2;
			//s0 = NeuronState[TotalNeurons - NUM_SENSORY] ;
			//s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1] = 1;
			//s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2]=1;
			//s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3];

			//for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			//{
			//	NextNeuronState(x);
			//}
			//if ((n0 == 2) && (s1 == 1) && (s2 == 1) && (NeuronState[2] == 0))
			//	Howfit[x]++;

			ClearAnimate(x);
			n0 = NeuronState[0] = 2;
			s0 = NeuronState[TotalNeurons - NUM_SENSORY]=1;
			s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1]=1 ;
			s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2] ;
			s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			if ((n0 == 2) && (s0 == 1) && (s1 == 1) && (NeuronState[2] == 0))
				Howfit[x]++;

			ClearAnimate(x);
			n0 = NeuronState[0] = 2;
			s0 = NeuronState[TotalNeurons - NUM_SENSORY] = 1;
			s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1] ;
			s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2]=1;
			s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3];

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			if ((n0 == 2) && (s0 == 1) && (s2 == 1) && (NeuronState[2] == 0))
				Howfit[x]++;



			ClearAnimate(x);
			n0 = NeuronState[0] = 2;
			s0 = NeuronState[TotalNeurons - NUM_SENSORY] ;
			s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1];
			s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2] = 1;
			s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3]=1;

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			if ((n0 == 2) && (s2 == 1) && (s3 == 1) && (NeuronState[2] == 0))
				Howfit[x]++;
			break;


			ClearAnimate(x);
			n0 = NeuronState[0] = 2;
			s0 = NeuronState[TotalNeurons - NUM_SENSORY];
			s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1]=1;
			s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2];
			s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3] = 1;

			for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			{
				NextNeuronState(x);
			}
			if ((n0 == 2) && (s1 == 1) && (s3 == 1) && (NeuronState[2] == 0))
				Howfit[x]++;
			break;

			//ClearAnimate(x);
			//n0 = NeuronState[0] = 2;
			//s0 = NeuronState[TotalNeurons - NUM_SENSORY];
			//s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1]=1;
			//s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2] = 1;
			//s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3];

			//for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			//{
			//	NextNeuronState(x);
			//}
			//if ((n0 == 2) && (s1 == 1) && (s2 == 1) && (NeuronState[2] == 0))
			//	Howfit[x]++;



			//ClearAnimate(x);
			//n0 = NeuronState[0] = 0;
			//s0 = NeuronState[TotalNeurons - NUM_SENSORY];
			//s1 = NeuronState[TotalNeurons - NUM_SENSORY + 1] ;
			//s2 = NeuronState[TotalNeurons - NUM_SENSORY + 2] ;
			//s3 = NeuronState[TotalNeurons - NUM_SENSORY + 3];

			//for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
			//{
			//	NextNeuronState(x);
			//}
			//if ((n0 == 0) && (NeuronState[2] == 0))
			//	Howfit[x]++;

			case 15:                          // 4 Sensor Summer - ALT
				for (int i = 0; i < 4; i++)
				{
					ClearAnimate(x);
					n0 = NeuronState[0] = 0;
					NeuronState[TotalNeurons - NUM_SENSORY + i] = 1;
					testrow[0] = NeuronState[TotalNeurons - NUM_SENSORY];
					testrow[1] = NeuronState[TotalNeurons - NUM_SENSORY + 1];
					testrow[2] = NeuronState[TotalNeurons - NUM_SENSORY + 2];
					testrow[3] = NeuronState[TotalNeurons - NUM_SENSORY + 3];

					for (int cycles = 0; cycles < NUM_CYCLES; cycles++)
					{
						NextNeuronState(x);
					}
					if ((n0 == 0) && (testrow[i] == 1) && (NeuronState[2] == 1))
						Howfit[x]++;
				}
				break;
		}
	}
	ClearAnimate(totalpop-1);
}

void Neuron::displaypopulation()
{

	for (int i = 0; i < totalchrome; i++)
	{
		numout(hwndEdit2, i, ADDTAB);
		textout(hwndEdit2, (LPSTR)L"Pool Index =",NOLINEFEED);
		numout(hwndEdit2, Beings[0][i], ADDTAB);
		textout(hwndEdit2, (LPSTR)L"Synapse =", NOLINEFEED);

		numout(hwndEdit2, SynapsePool[Beings[0][i]].start, NOLINEFEED);
		numout(hwndEdit2, SynapsePool[Beings[0][i]].end, NOLINEFEED);
		numout(hwndEdit2, SynapsePool[Beings[0][i]].sign, LINEFEED);
	}

}

void Neuron::Draw(HDC hdc, int *individual)
{
#define NUM_BRUSHES 5
#define DOT_SIZE 10
#define MAXLINEOUT 255

	int start_x, start_y;
	int end_x, end_y;
	int deltaX, deltaY;
	int x;
	int i;
	int mouthSize;
	int mouthFactor;
	int loopX, loopY;
	int lastX, lastY,firstX,firstY;
	int highlightFlag;

	int dspWidth, dspHeight,dspSpacingX, dspSpacingY;
	int posX, posY;
	int globalScaleFactor;
	int looper,graphcount;
	Neuron *currentNeuronPTR;
	int *localindividual;
	int txtlen;

	WCHAR sszText[MAXLINEOUT];
	WCHAR sszText2[MAXLINEOUT];
	HBRUSH hStateBrush[NUM_BRUSHES];
	HPEN hPenShapes;
	HPEN hPenPlusLine;
	HPEN hPenNegLine;

	//PAINTSTRUCT ps;
	HBRUSH hBlackBrush = CreateSolidBrush(RGB(0, 255, 255));
	HBRUSH hWhiteBrush = CreateSolidBrush(RGB(255, 255, 255));
	HBRUSH hDialogBrush = CreateSolidBrush(RGB(219, 221, 200));
	HBRUSH hCritterBrush = CreateSolidBrush(RGB(244, 205, 88));

	// need a more elegant init routing
	hStateBrush[0]= CreateSolidBrush(RGB(239, 239, 230));
	hStateBrush[1] = CreateSolidBrush(RGB(247, 241, 64));
	hStateBrush[2] = CreateSolidBrush(RGB(66, 217, 244));
	hStateBrush[3] = CreateSolidBrush(RGB(244, 146, 61));
	hStateBrush[4] = CreateSolidBrush(RGB(255, 0, 0));

	hPenShapes = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	hPenPlusLine = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	hPenNegLine = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	SelectObject(hdc, hPenShapes);

	looper = 1;
	if (CritterOwner != NULL)
	{
		globalScaleFactor = CritterOwner->globalNeuronPTR->scaleFactor;
		//currentNeuronPTR = CritterOwner->globalNeuronPTR;
		looper = CritterOwner->numBrains;
	}
	else
	{
		globalScaleFactor = scaleFactor;
		//currentNeuronPTR = this;
	}

	if (globalScaleFactor < 1) globalScaleFactor = 1;

	HDC memDC = CreateCompatibleDC(hdc);
	HBITMAP memBitmap = CreateCompatibleBitmap(hdc, deviceWidth - PANEL_X - BORDER_X, deviceHeight - PANEL_Y - BORDER_Y);
	SelectObject(memDC, memBitmap);

	SelectObject(memDC, hWhiteBrush);
	SetBkMode(memDC, TRANSPARENT);

	//Rectangle(hdc, PANEL_X, PANEL_Y, PANEL_X + deviceWidth - PANEL_X - BORDER_X, PANEL_Y + deviceHeight - PANEL_Y - BORDER_Y);
	Rectangle(memDC, 0, 0,   deviceWidth - PANEL_X - BORDER_X, deviceHeight - PANEL_Y - BORDER_Y);

	//SelectObject(hdc, hBlackBrush);
	for (graphcount = 0; graphcount < looper; graphcount++)
	{
		if ((CritterOwner != NULL) && (globalScaleFactor>1))
		{
			currentNeuronPTR = CritterOwner->brainPTR[graphcount];
			localindividual = currentNeuronPTR->Beings[0];
			loopX = 0;
			loopY = 0;
			if (CritterOwner->curBrain == graphcount)
				highlightFlag = TRUE;
			else highlightFlag = FALSE;
		}
		else
		{
			currentNeuronPTR = this;
			localindividual = individual;
			loopX = 0;
			loopY = 0;
			highlightFlag = FALSE;
		}


		x = Cursor;
		dspWidth = sqrt(currentNeuronPTR->TotalNeurons) * 1;
		dspHeight = sqrt(currentNeuronPTR->TotalNeurons) * 3;
		dspSpacingX = (currentNeuronPTR->deviceWidth - PANEL_X - BORDER_X - N_BORDER_X) / dspWidth;
		dspSpacingY = (currentNeuronPTR->deviceHeight - PANEL_Y - BORDER_Y - N_BORDER_Y) / dspHeight;

		if (globalScaleFactor > 1)
		{
			loopX = ((graphcount % (globalScaleFactor)) * ((currentNeuronPTR->deviceWidth - PANEL_X - BORDER_X - N_BORDER_X) / globalScaleFactor));
			loopY = ((graphcount/ (globalScaleFactor))  * ((currentNeuronPTR->deviceHeight - PANEL_Y - BORDER_Y - N_BORDER_Y) / globalScaleFactor));
		}

		if (highlightFlag == TRUE)
		{
			SelectObject(memDC, hPenNegLine);
			SelectObject(memDC, hWhiteBrush);
			SetBkMode(memDC, TRANSPARENT);
			Rectangle(memDC, loopX+ N_BORDER_X, loopY+N_BORDER_Y, 
				loopX+ (deviceWidth - PANEL_X - BORDER_X + N_BORDER_X)/globalScaleFactor, 
				loopY+ ((deviceHeight - PANEL_Y - BORDER_Y + N_BORDER_Y) / globalScaleFactor)*.75) ;
		}

		SelectObject(memDC, hBlackBrush);

		for (i = 0; i < currentNeuronPTR->totalchrome; i++)
		{


			start_x = currentNeuronPTR->SynapsePool[localindividual[i]].start;
			//temp=SynapsePool[localindividual[i]].start
			//start_x = indivitual[i]SynapsePool[localindividual[i]].start;
			posX = start_x % dspWidth;
			posY = start_x / dspWidth;

			//posX = posX *(NEURON_DISP_SIZE + dspSpacingX) + PANEL_X + N_BORDER_X +NEURON_DISP_SIZE/2;
			//posY = posY*(NEURON_DISP_SIZE + dspSpacingY) + PANEL_Y + N_BORDER_Y + NEURON_DISP_SIZE / 2;
			posX = posX *(NEURON_DISP_SIZE + dspSpacingX) + (N_BORDER_X*globalScaleFactor) + NEURON_DISP_SIZE / 2;
			posY = posY*(NEURON_DISP_SIZE + dspSpacingY) + (N_BORDER_Y*globalScaleFactor) + NEURON_DISP_SIZE / 2;

			posX = posX / globalScaleFactor + loopX;
			posY = posY / globalScaleFactor +loopY;

			if (start_x == 0)
			{
				firstX = posX;
				firstY = posY;
			}

			MoveToEx(memDC, posX, posY, NULL);
			deltaX = posX; deltaY = posY;

			end_x = currentNeuronPTR->SynapsePool[localindividual[i]].end;
			posX = end_x % dspWidth;
			posY = end_x / dspWidth;

			//posX = posX *(NEURON_DISP_SIZE + dspSpacingX) + PANEL_X + N_BORDER_X + NEURON_DISP_SIZE / 2;
			//posY = posY*(NEURON_DISP_SIZE + dspSpacingY) + PANEL_Y + N_BORDER_Y + NEURON_DISP_SIZE / 2;
			posX = posX *(NEURON_DISP_SIZE + dspSpacingX) + (N_BORDER_X*globalScaleFactor) + NEURON_DISP_SIZE / 2;
			posY = posY*(NEURON_DISP_SIZE + dspSpacingY) + (N_BORDER_Y*globalScaleFactor) + NEURON_DISP_SIZE / 2;

			posX = posX / globalScaleFactor + loopX;
			posY = posY / globalScaleFactor + loopY;


			if ((end_x == 2) && (globalScaleFactor>1))
			{
				CritterOwner->lastX[graphcount] = posX;
				CritterOwner->lastY[graphcount] = posY;
			}

			deltaX = posX - deltaX;
			deltaY = posY - deltaY;

			if ((currentNeuronPTR->SynapsePool[localindividual[i]].sign == POSITIVE) || (inhibitState == FALSE))
				SelectObject(memDC, hPenPlusLine);
			else 	SelectObject(memDC, hPenNegLine);


			LineTo(memDC, posX, posY);
			posX = posX - deltaX / NEURON_DISP_SIZE; posY = posY - deltaY / NEURON_DISP_SIZE;

			posX = posX / globalScaleFactor;
			posY = posY / globalScaleFactor;

			SelectObject(memDC, hPenShapes);
			if (globalScaleFactor == 1)
				Ellipse(memDC, posX - ((DOT_SIZE / 2) / globalScaleFactor), posY - ((DOT_SIZE / 2) / globalScaleFactor), posX + (DOT_SIZE / globalScaleFactor), posY + (DOT_SIZE / globalScaleFactor));

		}
		// now draw the line that connects that last output to the input.
		if (looper > 1)
		{
			int tempX, tempY;
			if (graphcount == 0)
			{
				tempX = CritterOwner->lastX[CritterOwner->numBrains-1];
				tempY = CritterOwner->lastY[CritterOwner->numBrains - 1];
			}
			else
			{
				tempX = CritterOwner->lastX[graphcount - 1];
				tempY = CritterOwner->lastY[graphcount - 1];
			}
			SelectObject(memDC, hPenPlusLine);
			MoveToEx(memDC, firstX,firstY, NULL);
			if (tempX>0 && tempY>0)
				LineTo(memDC, tempX, tempY);

		}
		for (i = 0; i < currentNeuronPTR->TotalNeurons; i++)
		{
			if (currentNeuronPTR->NeuronState[i] < NUM_BRUSHES)
				SelectObject(memDC, hStateBrush[currentNeuronPTR->NeuronState[i]]);
			else SelectObject(memDC, hStateBrush[NUM_BRUSHES - 1]);

			posX = i % dspWidth;
			posY = i / dspWidth;
			posX = posX *(NEURON_DISP_SIZE + dspSpacingX) + (N_BORDER_X*globalScaleFactor);
			posY = posY*(NEURON_DISP_SIZE + dspSpacingY) + (N_BORDER_Y*globalScaleFactor);

			posX = posX / globalScaleFactor + loopX;
			posY = posY / globalScaleFactor + loopY;
			Ellipse(memDC, posX, posY, posX + (NEURON_DISP_SIZE / globalScaleFactor), posY + (NEURON_DISP_SIZE / globalScaleFactor));
			//_itow_s(i, sszText, 10);
			_itow_s(currentNeuronPTR->NeuronState[i], sszText, 10);

			if (globalScaleFactor == 1)
				TextOut(memDC, posX + NEURON_DISP_SIZE / 4 + 7, posY + NEURON_DISP_SIZE / 4+3, sszText, _tcslen(sszText));
		}

		if (highlightFlag==TRUE)
		{

				swprintf_s(sszText2, MAXLINEOUT, L"Cycle Count = %i   Name = %s",  currentNeuronPTR->animCount, currentNeuronPTR->name);
				TextOut(memDC, 5, 5, sszText2, _tcslen(sszText2));
		}

		else
		{
			if (globalScaleFactor == 1)
			{
				swprintf_s(sszText2, MAXLINEOUT,
					L"Generation = %i localindividual = %i Cycle Count = %i   Name = %s",
					currentNeuronPTR->gencounter, currentNeuronPTR->Cursor, currentNeuronPTR->animCount, currentNeuronPTR->name);

				TextOut(memDC, 5, 5, sszText2, _tcslen(sszText2));
				//TextOut(memDC,  5,  5, sszText, _tcslen(sszText));

				if (CritterOwner != NULL)
				{

					swprintf_s(sszText2, MAXLINEOUT, L"Total Neurons = %i   Total Synapse = %i", CritterOwner->neuronCount, CritterOwner->chromeCount);
					txtlen = _tcslen(sszText2);
					TextOut(memDC, 5 , 25, sszText2, txtlen);
				}
				else
				{
					_itow_s(Howfit[x], sszText, 10);
					_tcscpy_s(sszText2, MAXLINEOUT, L"Best Fit: ");
					_tcscat_s(sszText2, MAXLINEOUT, sszText);
					TextOut(memDC, 5, 25, sszText2, _tcslen(sszText2));
				}
			}
		}


		//TextOut(hdc, PANEL_X + 5, PANEL_Y + 5, sszText2, _tcslen(sszText2));


		//TextOut(hdc, PANEL_X + 5, PANEL_Y + 25, sszText2, _tcslen(sszText2));

		//TextOut(memDC,  5, 25, sszText, _tcslen(sszText));
	}

	// *********** Draw sub windows
	int d_topx, d_topy;

	int currentline,oldline;
	d_topx = D_PANEL_X;
	d_topy = D_PANEL_Y;

	switch (DrawModeIndex)
	{
	case 1:       // +I/O ******************************************************

		currentline = 0;
		SelectObject(memDC, hDialogBrush);
		Rectangle(memDC, d_topx, d_topy, d_topx + D_PANEL_W, d_topy + D_PANEL_H);
		_tcscpy_s(sszText2, MAXLINEOUT, L"Neural Dashboard");
		txtlen = _tcslen(sszText2);
		TextOut(memDC, d_topx + (D_PANEL_W / 2) - ((txtlen * 8) / 2), d_topy + 5, sszText2, txtlen);
		currentline = 1;
		_tcscpy_s(sszText2, MAXLINEOUT, L"Input Nodes");
		txtlen = _tcslen(sszText2);
		TextOut(memDC, d_topx + 20, d_topy + 5 + (currentline*D_PANEL_LINESPC), sszText2, txtlen);
		_tcscpy_s(sszText2, MAXLINEOUT, L"Output Nodes");
		txtlen = _tcslen(sszText2);
		TextOut(memDC, d_topx + 20 + (D_PANEL_W / 2), d_topy + 5 + (currentline*D_PANEL_LINESPC), sszText2, txtlen);

		currentline++;
		oldline = currentline;
		DispNode(memDC, hStateBrush, 0, currentline, 0);
		currentline++;
		DispNode(memDC, hStateBrush, 1, currentline, 0);

		DispNode(memDC, hStateBrush, 2, oldline++, 1);
		DispNode(memDC, hStateBrush, 3, oldline++, 1);
		DispNode(memDC, hStateBrush, 4, oldline++, 1);

		DispNode(memDC, hStateBrush, TotalNeurons - NUM_MUSCLES, oldline++, 1);
		break;

	case 2:       // Creature Feature ******************************************************
#define MOUTH_SIZEBASE 30
#define MOUTH_MINIMUM 20
#define BODY_NUMSEGMENTS 6
#define BODY_XOFFSET 15
#define BODY_YOFFSET 15
#define BODY_SEGMENTSIZE 120
		int body_PosX, body_PosY;
		currentline = 0;
		SelectObject(memDC, hDialogBrush);
		Rectangle(memDC, d_topx, d_topy, d_topx + D_PANEL_W, d_topy + D_PANEL_H);
		_tcscpy_s(sszText2, MAXLINEOUT, L"Creature Feature");
		txtlen = _tcslen(sszText2);
		TextOut(memDC, d_topx + (D_PANEL_W / 2) - ((txtlen * 8) / 2), d_topy + 5, sszText2, txtlen);
		currentline = 1;
		if (CritterOwner != NULL)
			mouthFactor = CritterOwner->CritterMuscle[0]->state;
		else mouthFactor = 0;

		if (CritterOwner != NULL)
		{

			//swprintf_s(sszText2, MAXLINEOUT, L"Total Neurons = %i   Total Synapse = %i", CritterOwner->neuronCount, CritterOwner->chromeCount);
			//txtlen = _tcslen(sszText2);
			//TextOut(memDC, d_topx + 20, d_topy + 5 + (currentline*D_PANEL_LINESPC), sszText2, txtlen);
			//currentline++;
		}


		swprintf_s(sszText2, MAXLINEOUT, L"Muscle 0 = %i", mouthFactor);
		txtlen = _tcslen(sszText2);
		TextOut(memDC, d_topx + 20, d_topy + 5 + (currentline*D_PANEL_LINESPC), sszText2, txtlen);

		mouthSize = MOUTH_MINIMUM + (mouthFactor * MOUTH_SIZEBASE);
		posX = d_topx + (D_PANEL_W / 2) - (mouthSize / 2);
		posY = d_topy + (D_PANEL_H / 2) + 30;

		// draw the fake body
		SelectObject(memDC, hCritterBrush);
		for (int i = BODY_NUMSEGMENTS; i > 0; i--)
		{
			//body_PosX = (i-1)*BODY_XOFFSET + d_topx + (D_PANEL_W / 2) - ((BODY_SEGMENTSIZE - (BODY_XOFFSET * i)) / 2);
			body_PosX = d_topx + (D_PANEL_W / 2) - ((BODY_SEGMENTSIZE - (BODY_XOFFSET * i)) / 2);

			body_PosY = (i-1)*BODY_YOFFSET + posY;
			Ellipse(memDC, body_PosX, body_PosY, body_PosX + (BODY_SEGMENTSIZE - (BODY_XOFFSET * i)), body_PosY + ((BODY_SEGMENTSIZE-(BODY_YOFFSET*i) ) / 2));
		}

		if (mouthFactor<NUM_BRUSHES)
			SelectObject(memDC, hStateBrush[mouthFactor]);
		else SelectObject(memDC, hStateBrush[NUM_BRUSHES - 1]);

		Ellipse(memDC, posX, posY, posX + mouthSize, posY + (mouthSize/2));

		// draw sense grid
#define SG_SIZE 30
#define SG_YADJUST 55
		SelectObject(memDC, hWhiteBrush);
		posX=d_topx+ (D_PANEL_W / 2) - (SG_SIZE);
		posY = d_topy + (D_PANEL_H / 2) - SG_YADJUST;
		int index=0;
		int cellColor=0;
		Neuron *localNeuronPTR;

		if (CritterOwner == NULL)
			localNeuronPTR = this;
		else localNeuronPTR = CritterOwner->globalNeuronPTR;

		for (int i = 0; i < 4; i++)
			cellColor += localNeuronPTR->Sensory[i];

		for (int i = 0; i < 2; i++)
		{
			for (int j = 0; j < 2; j++)
			{
				if (localNeuronPTR->Sensory[index] > 0)
				{
					if (cellColor<NUM_BRUSHES)
						SelectObject(memDC, hStateBrush[cellColor]);
					else SelectObject(memDC, hStateBrush[NUM_BRUSHES - 1]);
				}
				else
				{
					SelectObject(memDC, hStateBrush[0]);
				}
				index++;

				Rectangle(memDC, posX + (SG_SIZE*j), posY + (SG_SIZE*i), posX + (SG_SIZE*j) + SG_SIZE+1, posY + (SG_SIZE*i) + SG_SIZE+1);
			}
		}

		
		break;
		
	}

	BitBlt(hdc, PANEL_X, PANEL_Y, deviceWidth - PANEL_X - BORDER_X, deviceHeight - PANEL_Y - BORDER_Y,
	memDC, 0, 0, SRCCOPY);

	DeleteObject(hBlackBrush);
	DeleteObject(hWhiteBrush);
	DeleteObject(hDialogBrush);
	DeleteObject(hStateBrush[0]);
	DeleteObject(hStateBrush[1]);
	DeleteObject(hStateBrush[2]);
	DeleteObject(hStateBrush[3]);
	DeleteObject(hCritterBrush);
	DeleteObject(hPenShapes);
	DeleteObject(hPenPlusLine);
	DeleteObject(hPenNegLine);

	DeleteDC(memDC);
	DeleteObject(memBitmap);

	//InvalidateRect(hWnd, NULL, FALSE);
}

void Neuron::DispNode(HDC hdc, HBRUSH *hStateBrush,int node, int currentline, int column)
{
	int posX, posY;

	if (node >= TotalNeurons)
		return;
	if (NeuronState[node]<NUM_BRUSHES)
		SelectObject(hdc, hStateBrush[NeuronState[node]]);
	else SelectObject(hdc, hStateBrush[NUM_BRUSHES - 1]);

	posX = D_PANEL_X +30 +(column *((D_PANEL_W / 2)+20));
	posY = D_PANEL_Y + 5 + (currentline*D_PANEL_LINESPC);

	Ellipse(hdc, posX, posY, posX + NEURON_DISP_SIZE, posY + NEURON_DISP_SIZE);
	//_itow_s(i, sszText, 10);
	_itow_s(NeuronState[node], sszText, 10);
	TextOut(hdc, posX + NEURON_DISP_SIZE / 4+4, posY + NEURON_DISP_SIZE / 4, sszText, _tcslen(sszText));
	swprintf_s(sszText, 50, L"Node %i", node);
	TextOut(hdc, posX + 40, posY + NEURON_DISP_SIZE/4, sszText, _tcslen(sszText));
	
}

void Neuron::Animate(HWND hWnd,int BeingIndex)
{
#define NUM_ANIMATIONS 20
#define ANIMATION_DELAY 200



	ClearAnimate(BeingIndex);
	for (int i = 0; i < NUM_ANIMATIONS; i++)
	{

		AnimateONE(hWnd,BeingIndex);
	    Sleep(ANIMATION_DELAY);
	}

	ClearAnimate(BeingIndex);
}

void Neuron::AnimateONE(HWND hWnd,int BeingIndex)
{
	//PAINTSTRUCT ps;
	//HDC hdc = BeginPaint(hWnd, &ps);
	NextNeuronState(BeingIndex);


	//Draw(hdc, Beings[Cursor]);
	//EndPaint(hWnd, &ps);
	//InvalidateRect(hWnd, NULL, FALSE);
	//ShowWindow(hWnd, SW_SHOW);
	//SetFocus(hWnd);
}

void Neuron::ClearAnimate(int BeingIndex)
{
	int index;
	for (int i = 0; i < TotalNeurons; i++)
	{
		NeuronState[i] = 0;
		//if (SynapsePool[Beings[BeingIndex][i]].start == 0)
	}
	NeuronState[0] = nodeZeroValue;
	NeuronState[1] = nodeOneValue;
	if (TotalNeurons > NUM_SENSORY + MIN_AVAIL_NEURONS)  // 5 includes 2 input and 2 output nodes
	{
		for (int i = 0; i< NUM_SENSORY;i++)
		{ 
			index = TotalNeurons - NUM_SENSORY + i;
			NeuronState[index] = Sensory[i];
		}
	}
	animCount = 0;
	//for (int i = 0; i < totalchrome; i++) NeuronState[i] = 0;
}

void Neuron::NextNeuronState(int BeingIndex)
{
	int temp,cursorstart;
	// clear out the temp states
	animCount++;
	
	for (int i = 0; i < TotalNeurons; i++)
	{
		tempState[i] = 0;
	}
	for (int i = 0; i < TotalNeurons; i++)
	{
		cursorstart = i;
		if (NeuronState[i] > 0)
		{
			for (int j = 0; j < totalchrome; j++)
			{
				if (SynapsePool[Beings[BeingIndex][j]].start == cursorstart)
				{
					temp = SynapsePool[Beings[BeingIndex][j]].end;

					if ((SynapsePool[Beings[BeingIndex][j]].sign == POSITIVE) || (inhibitState==FALSE))
					{
						tempState[temp] += NeuronState[i];
					}
					else 
					{
						tempState[temp] -= NeuronState[i];
					}
				}
			}
		}
	}
	// Now clean up an boundary conditions (neuron vals < or greater than max)
	for (int i = 0; i < TotalNeurons; i++)
	{
		if (tempState[i] < 0)
			tempState[i] = 0;
		if (tempState[i] > maxNodeValue)
			tempState[i] = maxNodeValue;
	}
	arraycpy(NeuronState, tempState, TotalNeurons);
}

void Neuron::CrossOver(int *parent1, int *parent2)
{
	// Create new child tour

	int startPos, endPos;
	for (int i = 0; i < totalchrome; i++)
		child[i] = NULL;
	// Get start and end sub tour positions for parent1's tour
	startPos = rand() % totalchrome;
	endPos = rand() % totalchrome;

	arraycpy(child, parent2, totalchrome);
	// Loop and add the sub tour from parent1 to our child
	for (int i = 0; i < totalchrome; i++) {
		// If our start position is less than the end position
		if ((startPos < endPos) && (i > startPos) && (i < endPos)) {
			child[i] = parent1[i];
		} // If our start position is larger
		else if (startPos > endPos) {
			if (!((i < startPos) && (i > endPos))) {
				child[i] = parent1[i];
			}
		}
	}

	// Loop through parent2's city tour
	//for (int i = 0; i < totalchrome; i++) {
	//	// If child doesn't have the city add it
	//	if (!contains(child, parent2[i], totalchrome)) {
	//		// Loop to find a spare position in the child's tour
	//		for (int ii = 0; ii < totalchrome; ii++) {
	//			// Spare position found, add city
	//			if (child[ii] == NULL) {
	//				child[ii] = parent2[i];
	//				break;
	//			}
	//		}
	//	}
	//}
}
void Neuron::Mutate(int index)
{
	int tourPos1, tourPos2;

	int mfactor;
	int u, range_min, range_max;

	range_min = 0; range_max = 1000;
	mfactor = range_max*mutationRate;
	u = (double)rand() / (RAND_MAX + 1) * (range_max - range_min)
		+ range_min;
	//rd = rand()/ RAND_MAX;
	// Loop through tour cities
	for (tourPos1 = 0; tourPos1 < totalchrome; tourPos1++) {
		// Apply mutation rate
		if (u < mfactor) {
			//// Get a second random position in the tour
			//tourPos2 = rand() % totalchrome;

			//// Get the cities at target position in tour
			//city1 = Children[index][tourPos1];
			//city2 = Children[index][tourPos2];

			//// Swap them around
			//Children[index][tourPos2] = city1;
			//Children[index][tourPos1] = city2;
			tourPos2 = rand() % totalchrome;
			Children[index][tourPos1] = rand() % SizeofPool;
			Children[index][tourPos2] = rand() % SizeofPool;
		}
	}
}

void Neuron::CreateControls(HWND hWnd, ControlIT *Controler)
{
	TCHAR comboText[18][30] =
	{
		TEXT("TEST CASE - Total On"), TEXT("5 output hold"), TEXT("Play Ground"),
		TEXT("Bllinker"), TEXT("2 Volt Select"), TEXT("2 Bit MUX"),
		TEXT("3 Counter"), TEXT("3 Delay"), TEXT("Multi-Input"),
		TEXT("Voltage Latch"), TEXT("Input propigation with delay"), TEXT("2 Volt Filter"),
		TEXT("4 Sensor summer"), TEXT("1 Pixel Filter"), TEXT("Diag Filter"),
		TEXT("4 Sensor summer - ALT"), TEXT("FUTURE"), TEXT("FUTURE")
	};

	TCHAR comboTextDRAW [4][30] =
	{
		TEXT("DRAW MODE -Neurons"), TEXT("+ I/O"), TEXT("Creature Feature"),TEXT("FUTURE")
	};

	TCHAR A[30];

	int index;
	int k;
	Population::CreateControls(hWnd, Controler);
	//Controler->controlCount += 3;
	//Controler->controlCount = Controler->controlCount + (3-(Controler->controlCount % 3)) ;
	Controler->MakeControl(hWnd, CT_LABEL, L"Neuron Controls", NULL, 0, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Switch Display", NULL, TSP_BTN_TOGGLE, NULL, 0);
	//Controler->MakeControl(hWnd, CT_BUTTON, L"Reset Paths", NULL, TSP_BTN_NEWPATHS, NULL, 0);
	//Controler->MakeControl(hWnd, CT_BUTTON, L"Heuristic", NULL, TSP_BTN_HEURISTIC, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Animate STEP", NULL, NEU_BTN_ANIMATE, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Next Critter", NULL, NEU_BTN_INCREMENT, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Animate CYCLE", NULL, NEU_BTN_ANIMATECYCLE, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Animate FULL", NULL, NEU_BTN_ANIMATEFULL, NULL, 0);


	//Fields
	Controler->MakeControl(hWnd, CT_LABEL_PARAMS, L"Neuron Input Fields", NULL, 0, NULL, 0);
	//Controler->MakeControl(hWnd, CT_EDITBOX, L"Population Size", &totalpop, BASE_FLD_POPULATION, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Node Zero Value", &nodeZeroValue, NEU_FLD_NODEZERO, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Node One Value", &nodeOneValue, NEU_FLD_NODEONE, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Max Node Value", &maxNodeValue, NEU_FLD_MAXNODE, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Neurons",&TotalNeurons, 0, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Nunber of cycles", &NUM_CYCLES, NEU_FLD_NUMCYCLES, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Scale Factor", &scaleFactor, NEU_FLD_SCALEFACTOR, NULL, 0);

	//index = Controler->MakeControl(hWnd, CT_CHECKBOX, L"Inhibitors", NULL, NEU_FLD_INHIBIT, NULL, 0);

	//SendMessage(Controler->ctrlHWND[index], BM_SETCHECK, BST_CHECKED, 0);
	//inhibitState = IsDlgButtonChecked(hWnd, NEU_FLD_INHIBIT);
	


	// **************Create first combo box for testing
	index = Controler->MakeControl(hWnd, CT_COMBOBOX, L"Test COMBO Box", NULL, NEU_FLD_COMBO, NULL, 0);
	hwndCombo = Controler->ctrlHWND[index];

	memset(&A, 0, sizeof(A));
	for (k = 0; k < 18; k++)
	{
		wcscpy_s(A, sizeof(A) / sizeof(TCHAR), (TCHAR*)comboText[k]);
		// Add string to combobox.
		SendMessage(hwndCombo, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)A);
	}
	// Send the CB_SETCURSEL message to display an initial item 
	//  in the selection field  
	SendMessage(hwndCombo, CB_SETCURSEL, (WPARAM)NeuronTypeIndex, (LPARAM)0);
	// make the main output window

	// ************** Build the Draw Mode Combobox
	index = Controler->MakeControl(hWnd, CT_COMBOBOX, L"Draw Mode", NULL, NEU_FLD_DRAWMODE, NULL, 0);
	hwndComboDraw = Controler->ctrlHWND[index];


	memset(&A, 0, sizeof(A));
	for (k = 0; k < 4; k++)
	{
		wcscpy_s(A, sizeof(A) / sizeof(TCHAR), (TCHAR*)comboTextDRAW[k]);
		// Add string to combobox.
		SendMessage(hwndComboDraw, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)A);
	}
	// Send the CB_SETCURSEL message to display an initial item 
	//  in the selection field  
	SendMessage(hwndComboDraw, CB_SETCURSEL, (WPARAM)DrawModeIndex, (LPARAM)0);

	Controler->MakeControl(hWnd, CT_EDITBOX, L"Sleep (MS)", &sleepMS, NEU_FLD_SLEEPMS, NULL, 0);
	// Sensory and Motor Neurons
	Controler->MakeControl(hWnd, CT_LABEL_PARAMS, L"Sensory and Motor Neurons", NULL, 0, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Sensory 0", &Sensory[0], NEU_FLD_S0, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Sensory 1", &Sensory[1], NEU_FLD_S1, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Sensory 2", &Sensory[2], NEU_FLD_S2, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Sensory 3", &Sensory[3], NEU_FLD_S3, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Sensory 4", &Sensory[4], NEU_FLD_S4, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Sensory 5", &Sensory[5], NEU_FLD_S5, NULL, 0);

Controler->MakeControl(hWnd, CT_EDITBOX, L"Muscle 0", &Muscle[0], NEU_FLD_M0, NULL, 0);
Controler->MakeControl(hWnd, CT_EDITBOX, L"Muscle 1", &Muscle[1], NEU_FLD_M1, NULL, 0);
Controler->MakeControl(hWnd, CT_EDITBOX, L"Muscle 2", &Muscle[2], NEU_FLD_M2, NULL, 0);





// make the main output window

LoadLibrary(TEXT("Msftedit.dll"));

hwndEdit2 = CreateWindowEx(WS_EX_STATICEDGE, MSFTEDIT_CLASS, TEXT(""),
	ES_MULTILINE | WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP | ES_AUTOVSCROLL | WS_VSCROLL,
	PANEL_X, PANEL_Y, deviceWidth - PANEL_X - BORDER_X, deviceHeight - PANEL_Y - BORDER_Y,
	hWnd, (HMENU)ID_EDITCHILD, (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), NULL);

hwndTitle = CreateWindow(
	L"static",  // Predefined class; Unicode assumed 
	L"Neurons",      // Button text 
	WS_TABSTOP | WS_VISIBLE | WS_CHILD,  // Styles 
	LEFT_EDGE,         // x position 
	PANEL_Y,         // y position 
	P_M_WIDTH + P_M_WIDTH,        // Button width
	P_M_HEIGHT + 10,        // Button height
	hWnd,     // Parent window
	(HMENU)0,       // No menu.
	(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
	NULL);      // Pointer not needed.

SendMessage(hwndTitle, WM_SETFONT, (WPARAM)Controler->fontTitle, MAKELPARAM(true, 0));

SetFocus(hWnd);

}

void Neuron::Initial_Message()
{
	textout(hwndEdit2, (LPSTR)L"Evolve 1.0 - Neurons", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"Dan Lovy", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"Welcome!", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"NOTE - Press [Switch Display] to change to GRAPHIC mode.", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"The goal is to create a general set of objects that can execute basic genetic algoithms and can be inherited to solve specific problems.  ", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"This implementaion applies genetic algorithms to artificial nervous systems. ", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"The basic genetic algorithm commands are the same as the Traveling Salesman implementation.", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"You can access this by selecting the <Switch Universe> menu option in the <File> menu.", LINEFEED);
	
	textout(hwndEdit2, (LPSTR)L" ", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"Detailed Release Notes and instructions will be posted at - ", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"www.danlovy.com/critter", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"Any questions, comments or critisms are most welcome and should be sent to:", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   Dan Lovy", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   danlovy1961@gmail.com", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"Enjoy", LINEFEED);

}

void Neuron::Inc_Cursor()
{
	Cursor++;
	if (Cursor >= totalpop) Cursor = 0;
}

void Neuron::set_point(int xpos, int ypos)
{
	int posX, posY;
	int d_topx, d_topy;
	int index;

	d_topx = D_PANEL_X+PANEL_X;
	d_topy = D_PANEL_Y+PANEL_Y;

	switch (DrawModeIndex)
	{
	case 2:       // Creature Feature
		posX = d_topx + (D_PANEL_W / 2) - (SG_SIZE);
		posY = d_topy + (D_PANEL_H / 2) - SG_YADJUST;

		if ((xpos > posX) && (ypos > posY) &&
			(xpos < (posX + (2 * SG_SIZE))) &&
			(ypos < (posY + (2 * SG_SIZE))))
			{
			index = (((xpos - posX) / SG_SIZE) + (2 * ((ypos - posY) / SG_SIZE)));
			if (Sensory[index] == 0)
				Sensory[index] = 1;
			else Sensory[index] = 0;
			}

		break;
	}
}

void Neuron::FreeStorage()

{

	delete[]SynapsePool;
	delete[]Howfit;
	delete[]Tournfit;
	delete[]NeuronState;
	delete[]tempState;
}

Neuron::~Neuron()
{

	FreeStorage();

}

