#pragma once
#include "population.h"
#include "DanFile.h"
#include "ControlIT.h"
//#include "Critter.h"
#include "time.h"

#define NEURON_DISP_SIZE 42
#define N_BORDER_X 50
#define N_BORDER_Y 50

#define NUM_SENSORY 6
#define NUM_MUSCLES 3
#define MIN_AVAIL_NEURONS 5

#define POSITIVE 1
#define NEGATIVE -1

typedef struct synapse {
	int start;
	int end;
	int sign;
};

class Critter;


class Neuron : public Population
{
private:

public:


	synapse *SynapsePool;   //All the different connections that can be made from Being to Being over the number of Chromesomes
	int *Howfit;
	int *Tournfit;
	int *NeuronState;
	int *tempState;

	int SizeofPool;
	int TotalNeurons;
	
	int NeuronTypeIndex;
	int DrawModeIndex;
	int nodeZeroValue;
	int nodeOneValue;
	int maxNodeValue;
	int animCount;

	TCHAR name[MAXPATH];

	// Sensory and Motor Neurons
	int Sensory[NUM_SENSORY];
	int Muscle[NUM_MUSCLES];

	HWND hwndCombo;
	HWND hwndComboDraw;

	int inhibitState;
	int NUM_CYCLES;
	int sleepMS;
	int scaleFactor;

	Critter  *CritterOwner;
//int *CritterOwner;


	Neuron(int, int, double,int);
	~Neuron();

	virtual void Init(int, int, TCHAR*);
	virtual void CalcFitness();
	//virtual void DrawHACK(HDC, int *,Critter );    // Yes, a hack, long story
	virtual void Draw(HDC, int *);
	virtual int Fittest();
	virtual int TournFittest();
	virtual void CalcOneFit(int, int);
	virtual void CrossOver(int *, int *);
	virtual void Mutate(int);
	virtual void CreateControls(HWND, ControlIT *);
	virtual void FreeStorage();
	virtual void Initial_Message();
	virtual void displaypopulation();
	virtual int fitnessLookup(int);
	virtual void Animate(HWND,int);
	virtual void AnimateONE(HWND,int);
	virtual void ClearAnimate(int);
	virtual void NextNeuronState(int);
	virtual void Inc_Cursor();
	virtual void set_point(int, int);

	virtual void DispNode(HDC,HBRUSH *,int, int, int);
	virtual void TableSearch(int *,int *, int, int);

};


