#include "stdafx.h"
#include "math.h"
#include "Population.h"
#include "Evolve.h"
#include "time.h"
#if !defined MSFTEDIT_CLASS
#define MSFTEDIT_CLASS L"RICHEDIT50W"
#endif


//****************************** BASE CLASS
// Constructor
Population::Population(int NEWtotalpop, int NEWtotalchrome,double NEWmutate,int NEWparam1)
{
	unsigned int time_ui = unsigned int(time(NULL));

	srand(time_ui);

	totalpop = NEWtotalpop;
	totalchrome = NEWtotalchrome;

	oldpop = NEWtotalpop;
	oldchrome = NEWtotalchrome;

	// these should be made parameters later
	elitism = 1;
	elitismOffset = 1;
	mutationRate = NEWmutate;

	child = new int[NEWtotalchrome];
	parent1 = new int[NEWtotalchrome];
	parent2 = new int[NEWtotalchrome];

	gencounter = 0;

	Beings = new int*[NEWtotalpop];
	Children = new int*[NEWtotalpop];
	Tournament = new int*[TOURNAMENTSIZE];

	for (int i = 0; i < totalpop; i++)
		Beings[i] = new int[NEWtotalchrome];


	for (int i = 0; i < totalpop; i++)
		Children[i] = new int[NEWtotalchrome];

	for (int i = 0; i < TOURNAMENTSIZE; i++)
		Tournament[i] = new int[NEWtotalchrome];

}

void Population::Init(int arg1, int arg2,TCHAR * brainname)
{

}

void Population::Evolve()
{
	int index;


	gencounter++;
	if (elitism==1) 
	{
		//newPopulation.saveTour(0, pop.getFittest());
		copytoChild(0, Fittest());
		elitismOffset = 1;
	}


	for (int i = elitismOffset; i < totalpop; i++)

	{
		// Select parents
		//Tour parent1 = tournamentSelection(pop);
		index = tournamentSelect();
		arraycpy(parent1, Tournament[index],totalchrome);
		//arrayparent1 = Tournament[index], totalchrome;
		//Tour parent2 = tournamentSelection(pop);
		index = tournamentSelect();
		arraycpy(parent2, Tournament[index], totalchrome);
		//arrayparent2 = Tournament[index], totalchrome;

		// Crossover parents
		//Tour child = crossover(parent1, parent2);
		CrossOver(parent1,parent2);
		// Add child to new population
		//newPopulation.saveTour(i, child);
		//for (int j = 0; j < totalchrome; j++)
		
			//Children[i][j] = Tournament[parent1][j];
			arraycpy(Children[i], child,totalchrome);

		

	}
	// Mutate the new population a bit to add some new genetic material
	for (int i = elitismOffset; i < totalpop; i++)
	{
		//mutate(newPopulation.getTour(i));
		Mutate(i);
	}

	// copy children to beings REMEMBER TO DO A CALC FITNESS
	for (int i = 0; i < totalpop; i++)
		copytoParent(i, i);
	CalcFitness();

}

int Population::tournamentSelect()
{
	int randomID;

	
	for (int i = 0; i < TOURNAMENTSIZE; i++)
	{
		randomID = rand() % totalpop;
		for (int j = 0; j < totalchrome; j++)
		{
			Tournament[i][j] = Beings[randomID][j];
		}
		CalcOneFit(i, randomID);

	}
	return (TournFittest());
}

void Population::Mutate(int index)
{
	int tourPos1, tourPos2;
	int city1, city2;
	
	int mfactor;
	int u, range_min, range_max;

	range_min = 0; range_max = 1000;
	mfactor = range_max*mutationRate;
	u = (double)rand() / (RAND_MAX + 1) * (range_max - range_min)
		+ range_min;
	//rd = rand()/ RAND_MAX;
	// Loop through tour cities
	for (tourPos1 = 0; tourPos1 < totalchrome; tourPos1++) {
		// Apply mutation rate
		if (u < mfactor) {
			// Get a second random position in the tour
			tourPos2 = rand () % totalchrome;

			// Get the cities at target position in tour
			city1 = Children[index][tourPos1];
			city2 = Children[index][tourPos2];

			// Swap them around
			Children[index][tourPos2] = city1;
			Children[index][tourPos1] = city2;
		}
	}
}
void Population::CalcOneFit(int i,int j)
{

}

int Population::fitnessLookup(int index)
{
	return 0;
}

int Population::Fittest()
{
	return 0;
}

int Population::TournFittest()
{
	return 0;
}

void Population::displaypopulation()
{

}

void Population::Draw(HDC hdc, int *individual)
{

}

void Population::CalcFitness()
{


}

void Population::CrossOver(int *parent1,int *parent2)
{
	// Create new child tour

	int startPos, endPos;
	for (int i = 0; i < totalchrome; i++)
		child[i] = NULL;
	// Get start and end sub tour positions for parent1's tour
	startPos = rand() % totalchrome;
	endPos = rand() % totalchrome;


	// Loop and add the sub tour from parent1 to our child
	for (int i = 0; i < totalchrome; i++) {
		// If our start position is less than the end position
		if ((startPos < endPos) && (i > startPos) && (i < endPos)) {
			child[i] = parent1[i];
		} // If our start position is larger
		else if (startPos > endPos) {
			if (!((i < startPos) && (i > endPos))) {
				child[i] = parent1[i];
			}
		}
	}

	// Loop through parent2's city tour
	for (int i = 0; i < totalchrome; i++) {
		// If child doesn't have the city add it
		if (!contains(child, parent2[i], totalchrome)) {
			// Loop to find a spare position in the child's tour
			for (int ii = 0; ii < totalchrome; ii++) {
				// Spare position found, add city
				if (child[ii] == NULL) {
					child[ii] = parent2[i];
					break;
				}
			}
		}
	}
}

void Population::CreateControls(HWND hWnd,ControlIT *Controler)
{
	// Buttons
	Controler->MakeControl(hWnd, CT_LABEL, L"Genetic Base Controls", NULL, 0, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"EVOLVE", NULL, BASE_BTN_EVOLVE, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"New World", NULL, BASE_BTN_NEWPOP, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"One Generation", NULL, BASE_BTN_ONEGENERATION, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Update Values", NULL, BASE_BTN_UPDATE, NULL, 0);

	// Fields
	Controler->MakeControl(hWnd, CT_LABEL_PARAMS, L"Base Input Fields", NULL, 0, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Population Size", &totalpop, BASE_FLD_POPULATION, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Chromosome Size", &totalchrome, BASE_FLD_CHROMOSOME, NULL, 0);
	Controler->MakeControl(hWnd, CT_EDITBOX, L"Mutation Rate", NULL, BASE_FLD_MUTATE, &mutationRate, FL_DOUBLE);
	//_itow_s(testgrid.GR_CELLSIZE, sszText, 10);



}

void Population::Initial_Message()
{

}


//// SOME UTILS //////////
bool Population::contains(int *source,int member, int size)
{
	bool retval = FALSE;
	for (int i = 0; i < size; i++)
	{
		if (source[i] == member)
		{
			retval = TRUE;
			return (retval);
		}
	}
	return (retval);
}
void Population::copytoChild(int dest, int source)
{
	
	for (int i = 0; i < totalchrome; i++)
	{
		Children[dest] [i] = Beings[source] [i];
	}

}

void Population::copytoParent(int dest, int source)
{
	for (int i = 0; i < totalchrome; i++)
	{
		Beings[dest] [i] = Children[source] [i];
	}

}

void Population::arraycpy(int *dest, int *src, int size)
{
	for (int i=0; i < size; i++)
		dest[i] = src[i];
}

void Population::FreeStorage()
{
	for (int i = 0; i < oldpop; i++)
	{
		delete[] Beings[i];
		delete[] Children[i];
	}
	for (int i = 0; i < TOURNAMENTSIZE; i++)
		delete[] Tournament[i];

	delete[] Beings;
	delete[] Children;
	delete[] Tournament;
	delete[] child;
	delete[] parent1;
	delete[] parent2;

}
Population::~Population()
{
	FreeStorage();
}


/////////////////// SOME UTILITES

