#include "stdafx.h"
#include "math.h"
#include "Population.h"
#include "Traveling.h"
#include "Evolve.h"
#include "time.h"
#if !defined MSFTEDIT_CLASS
#define MSFTEDIT_CLASS L"RICHEDIT50W"
#endif


//****************************** TRAVELING SALES PROBLEM CLASS
// Constructor
Traveling::Traveling(int NEWtotalpop, int NEWtotalchrome, double NEWmutate,int NEWparam1) :Population(NEWtotalpop, NEWtotalchrome, NEWmutate,NEWparam1)
{
	//Traveling(NEWtotalpop, NEWtotalchrome):Population(NEWtotalpop, NEWtotalchrome);  //Explicity call base constructor don't know why I have to?
	City_X = new int[NEWtotalchrome];
	City_Y = new int[NEWtotalchrome];
	Distances = new int[NEWtotalchrome];
	TotalDistance = new int[NEWtotalpop];
	TournDistance = new int[TOURNAMENTSIZE];


}

void Traveling::Init(int width, int height,TCHAR *brainname)
{
	deviceWidth = width;
	deviceHeight = height;

	NewPaths();
	for (int i = 0; i < totalchrome; i++)
	{
		City_X[i] = rand() % ((width - PANEL_X - BORDER_X) - CITYSIZE);
		City_Y[i] = rand() % ((height - PANEL_Y - BORDER_Y) - CITYSIZE - 40) + 40; //40 is to acccount for text output at top
	}
	CalcFitness();
}

void Traveling::NewPaths()
{
	int x, y;
	Cursor = 0;
	gencounter = 0;
	for (x = 0; x < totalpop; x++)
	{

		for (y = 0; y < totalchrome; y++)
		{
			//(testpopPTR)->Beings[x][y] = y + 10;
			Beings[x][y] = y;
			Children[x][y] = 0;
		}
		for (int i = 0; i < totalchrome; i++) {
			int r = rand() % totalchrome;  // generate a random position
			int temp = Beings[x][i]; Beings[x][i] = Beings[x][r]; Beings[x][r] = temp;

		}

	}

	x = 0;
	Beings[x][totalchrome - 1] = 0;
	for (y = 0; y < totalchrome - 1; y++)
	{

	}
}
int Traveling::TournFittest()
{
	int retval;

	retval = 0;
	for (int i = 1; i < TOURNAMENTSIZE; i++)
	{
		if (TournDistance[retval] >= TournDistance[i])
			retval = i;
	}

	return retval;
}



void Traveling::CalcOneFit(int i, int j)
{
	TournDistance[i] = TotalDistance[j];
}

int Traveling::fitnessLookup(int index)
{
	return(TotalDistance[index]);
}
int Traveling::Fittest()
{
	int retval;

	retval = 0;
	for (int i = 1; i < totalpop; i++)
	{
		if (TotalDistance[retval] >= TotalDistance[i])
			retval = i;
	}

	return retval;
}

void Traveling::CalcFitness()
{
	int start_x, start_y;
	int end_x, end_y;
	int xDistance, yDistance;
	double distance;
	for (int x = 0; x<totalpop; x++)
	{
		TotalDistance[x] = 0;
		for (int i = 0; i < totalchrome; i++)
		{
			start_x = City_X[Beings[x][i]]; start_y = City_Y[Beings[x][i]];
			if (i == (totalchrome - 1))
			{
				end_x = City_X[Beings[x][0]]; end_y = City_Y[Beings[x][0]];
			}
			else
			{
				end_x = City_X[Beings[x][i + 1]]; end_y = City_Y[Beings[x][i + 1]];
			}

			//Distances[i] = i;
			xDistance = abs(start_x - end_x);
			yDistance = abs(start_y - end_y);
			distance = sqrt((xDistance*xDistance) + (yDistance*yDistance));
			Distances[i] = distance;
			TotalDistance[x] += distance;
		}
	}
}
void Traveling::displaypopulation()
{
	int x, y;
	//Traveling *pop2 = (Traveling *)pop;
	for (x = 0; x < totalpop; x++)
	{
		_itow_s(x, sszText, 10);
		textout(hwndEdit2, (LPSTR)sszText, ADDTAB);
		_itow_s(City_X[x], sszText, 10);
		textout(hwndEdit2, (LPSTR)sszText, ADDTAB);
		_itow_s(City_Y[x], sszText, 10);
		textout(hwndEdit2, (LPSTR)sszText, ADDTAB);
		for (y = 0; y < totalchrome; y++)
		{
			_itow_s(Beings[x][y], sszText, 10);
			textout(hwndEdit2, (LPSTR)sszText, ADDTAB);
		}

		_itow_s(TotalDistance[x], sszText, 10);
		textout(hwndEdit2, (LPSTR)sszText, LINEFEED);

	}
	//textout(populationPTR->hwndEdit2, (LPSTR)L"", LINEFEED);
	//textout(populationPTR->hwndEdit2, (LPSTR)L"Fittest = ", NOLINEFEED);
	//numout(populationPTR->hwndEdit2, pop2->Fittest(), ADDTAB);
	//numout(populationPTR->hwndEdit2, pop2->TotalDistance[populationPTR->Fittest()], LINEFEED);

}

void Traveling::Draw(HDC hdc, int *individual)
{
	int start_x, start_y;
	int end_x, end_y;
	WCHAR sszText[50];
	WCHAR sszText2[50];

	//PAINTSTRUCT ps;
	HBRUSH hBlackBrush = CreateSolidBrush(RGB(0, 255, 255));
	HBRUSH hWhiteBrush = CreateSolidBrush(RGB(255, 255, 255));
	int x;
	int i;

	//HDC memDC = CreateCompatibleDC(hdc);
	//HBITMAP memBitmap = CreateCompatibleBitmap(hdc, deviceWidth - PANEL_X - BORDER_X, deviceHeight - PANEL_Y - BORDER_Y);
	//SelectObject(memDC, memBitmap);

	SelectObject(hdc, hWhiteBrush);
	Rectangle(hdc, PANEL_X, PANEL_Y, PANEL_X + deviceWidth - PANEL_X - BORDER_X, PANEL_Y + deviceHeight - PANEL_Y - BORDER_Y);
	//Rectangle(memDC, 0, 0,   deviceWidth - PANEL_X - BORDER_X, deviceHeight - PANEL_Y - BORDER_Y);

	SelectObject(hdc, hBlackBrush);
	x = Cursor;

	for (i = 0; i < totalchrome; i++)
	{
		start_x = City_X[individual[i]]; start_y = City_Y[individual[i]];
		if (i == (totalchrome - 1))
		{
			end_x = City_X[individual[0]]; end_y = City_Y[individual[0]];
		}
		else
		{
			end_x = City_X[individual[i + 1]]; end_y = City_Y[individual[i + 1]];
		}

		MoveToEx(hdc, start_x + PANEL_X + CITYSIZE / 2, start_y + PANEL_Y + CITYSIZE / 2, NULL);
		LineTo(hdc, end_x + PANEL_X + CITYSIZE / 2, end_y + PANEL_Y + CITYSIZE / 2);
		//MoveToEx(memDC, start_x + CITYSIZE / 2, start_y  + CITYSIZE / 2, NULL);
		//LineTo(memDC, end_x  + CITYSIZE / 2, end_y  + CITYSIZE / 2);
	}


	for (i = 0; i < totalchrome; i++)
	{
		Ellipse(hdc, PANEL_X + City_X[individual[i]], PANEL_Y +
			City_Y[individual[i]], PANEL_X + City_X[individual[i]] + CITYSIZE, PANEL_Y + City_Y[individual[i]] + CITYSIZE);
		//Ellipse(memDC,  City_X[individual[i]], 
		//	City_Y[individual[i]],  City_X[individual[i]] + CITYSIZE,  City_Y[individual[i]] + CITYSIZE);
	}

	_itow_s(gencounter, sszText, 10);
	_tcscpy_s(sszText2, 50, L"Generation: ");
	_tcscat_s(sszText2, 50, sszText);
	TextOut(hdc, PANEL_X + 5, PANEL_Y + 5, sszText2, _tcslen(sszText2));
	//TextOut(memDC,  5,  5, sszText, _tcslen(sszText));
	_itow_s(TotalDistance[x], sszText, 10);
	_tcscpy_s(sszText2, 50, L"Best Fit: ");
	_tcscat_s(sszText2, 50, sszText);

	TextOut(hdc, PANEL_X + 5, PANEL_Y + 25, sszText2, _tcslen(sszText2));
	//TextOut(memDC,  5, 25, sszText, _tcslen(sszText));



	//BitBlt(hdc, PANEL_X, PANEL_Y, deviceWidth - PANEL_X - BORDER_X, deviceHeight - PANEL_Y - BORDER_Y,
	// memDC, 0, 0, SRCCOPY);

	DeleteObject(hBlackBrush);
	//InvalidateRect(hWnd, NULL, FALSE);
}

void Traveling::Heuristic()
{
	int x, y;
	Cursor = 0;
	gencounter = 0;
	x = 0;

	for (y = 0; y < totalchrome; y++)
	{
		//(testpopPTR)->Beings[x][y] = y + 10;
		//Beings[x][y] = totalchrome+1;
		parent1[y] = 0;
		//Children[x][y] = 0;
	}



	int start_x, start_y;
	int end_x, end_y;

	int xDistance, yDistance;
	double distance;
	int retval;
	x = 0;

	TotalDistance[x] = 0;
	parent1[0] = 0;
	for (int i = 0; i < totalchrome; i++)
	{
		// calculate array of distances from current point in chrome
		start_x = City_X[parent1[i]]; start_y = City_Y[parent1[i]];
		for (int y = 0; y < totalchrome; y++)
		{



			end_x = City_X[y]; end_y = City_Y[y];

			if (contains(parent1, y, totalchrome))

			{
				Distances[y] = 10000;
			}
			else
			{
				//Distances[i] = i;
				xDistance = abs(start_x - end_x);
				yDistance = abs(start_y - end_y);
				distance = sqrt((xDistance*xDistance) + (yDistance*yDistance));
				Distances[y] = distance;
				TotalDistance[x] += distance;
			}
		}
		// now find the shortest distance
		retval = 0;
		for (int y = 0; y < totalchrome; y++)
		{


			if (Distances[retval] >= Distances[y])
				retval = y;


		}
		if ((i<totalchrome - 1))
			parent1[i + 1] = retval;
	}
	// now calc the distance for this one (messy will clean up later)
	TotalDistance[0] = 0;
	for (int i = 0; i < totalchrome; i++)
	{
		start_x = City_X[parent1[i]]; start_y = City_Y[parent1[i]];
		if (i == (totalchrome - 1))
		{
			end_x = City_X[parent1[0]]; end_y = City_Y[parent1[0]];
		}
		else
		{
			end_x = City_X[parent1[i + 1]]; end_y = City_Y[parent1[i + 1]];
		}

		//Distances[i] = i;
		xDistance = abs(start_x - end_x);
		yDistance = abs(start_y - end_y);
		distance = sqrt((xDistance*xDistance) + (yDistance*yDistance));
		Distances[i] = distance;
		TotalDistance[0] += distance;
	}

}

void Traveling::CreateControls(HWND hWnd, ControlIT *Controler)
{
	Population::CreateControls(hWnd, Controler);
	//Controler->controlCount += 3;
	//Controler->controlCount = Controler->controlCount + (3-(Controler->controlCount % 3)) ;
	Controler->MakeControl(hWnd, CT_LABEL, L"Traveling Salesman Controls", NULL, 0, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Switch Display", NULL, TSP_BTN_TOGGLE, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Reset Paths", NULL, TSP_BTN_NEWPATHS, NULL, 0);
	Controler->MakeControl(hWnd, CT_BUTTON, L"Heuristic", NULL, TSP_BTN_HEURISTIC, NULL, 0);

	//Controler->MakeControl(hWnd, CT_LABEL_PARAMS, L"Traveling Input Fields", NULL, 0, NULL, 0);





	// make the main output window
	LoadLibrary(TEXT("Msftedit.dll"));

	hwndEdit2 = CreateWindowEx(WS_EX_STATICEDGE, MSFTEDIT_CLASS, TEXT(""),
		ES_MULTILINE | WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP | ES_AUTOVSCROLL | WS_VSCROLL,
		PANEL_X, PANEL_Y, deviceWidth - PANEL_X - BORDER_X, deviceHeight - PANEL_Y - BORDER_Y,
		hWnd, (HMENU)ID_EDITCHILD, (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), NULL);

	hwndTitle = CreateWindow(
		L"static",  // Predefined class; Unicode assumed 
		L"Traveling Salesman",      // Button text 
		WS_TABSTOP | WS_VISIBLE | WS_CHILD,  // Styles 
		LEFT_EDGE,         // x position 
		PANEL_Y,         // y position 
		P_M_WIDTH + P_M_WIDTH,        // Button width
		P_M_HEIGHT+10,        // Button height
		hWnd,     // Parent window
		(HMENU)0,       // No menu.
		(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
		NULL);      // Pointer not needed.

	SendMessage(hwndTitle, WM_SETFONT, (WPARAM)Controler->fontTitle, MAKELPARAM(true, 0));



	SetFocus(hWnd);

}

void Traveling::Initial_Message()
{
	textout(hwndEdit2, (LPSTR)L"Evolove 1.0 Traveling Salesman ", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"Dan Lovy", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"Welcome!", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"NOTE - Press [Switch Display] to change to GRAPHIC mode.", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"The goal is to create a general set of objects that can execute basic genetic algoithms and can be inherited to solve specific problems.  The first being the classic Traveling Salesman.", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"Command Summary:", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"Base Genetic Commands", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   [EVOLVE] - Executes the genetic algorithm forever.  I will add a generation count later.  Due to some poor implementation ", NOLINEFEED);
	textout(hwndEdit2, (LPSTR)L"   this loop can only be broken by a mouse click or a key press.  The controls will also disapear during this infinite loop.  ", LINEFEED);

	//textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   [New World] - Generates the new population using the Population Size and Chromosome Size fields.  The mutatation rate is also set.  ", NOLINEFEED);
	textout(hwndEdit2, (LPSTR)L"May be adding tounament size variable later.  For the traveling saleman solution, chomosome size equals the number of cities.  I found that a 100X population to ", NOLINEFEED);
	textout(hwndEdit2, (LPSTR)L"chromosome size yiels great results for the TSM at higher numbers.  I will add profiling function to get more precise.  ", NOLINEFEED);
	textout(hwndEdit2, (LPSTR)L"This function also calls the inherited TSM class to create a random set of cities and initialize a random set of path solutions.", LINEFEED);
	//textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   [One Generation] - Makes a single call to the Evolve routine to execute only one generation at a time.", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"Traveling Salesman Commands", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   [Switch Display] - Toggles between the GRAPHIC on TEXT mode.  GRAPHIC mode will give more information. TEXT mode needs more work to be complete.", LINEFEED);
	//textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   [Reset Paths] - Generates a new population of random city paths while keeping the cities the same.", LINEFEED);
	//textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   [Heuristic] - Creates a solution that simply generations a path by starting at the first city, then selecting the next nearest city.  This will generate a pretty good solution, useful in comparing the quality of the evolved solution.", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"Most of these commands have a menu shortcut.", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"Any questions, comments or critisms are most welcome and should be sent to:", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   Dan Lovy", LINEFEED);
	textout(hwndEdit2, (LPSTR)L"   danlovy1961@gmail.com", LINEFEED);

	textout(hwndEdit2, (LPSTR)L"Enjoy", LINEFEED);

}

void Traveling::Inc_Cursor()
{
	Cursor++;
	if (Cursor >= totalpop) Cursor = 0;
}

void Traveling::FreeStorage()

{
	delete[]City_X;
	delete[]City_Y;
	delete[]TotalDistance;
	delete[]Distances;
	delete[]TournDistance;
}

Traveling::~Traveling()
{

	FreeStorage();

}
