#pragma once
#include "population.h"
#include "ControlIT.h"
#include "time.h"

//Constants for Traveling Salesman
#define SALESMAP_WIDTH 850
#define SALESMAP_HEIGHT 400
#define CITYSIZE 20
#define TOURNAMENTSIZE 5
#define MUTATIONRATE .015
#define BORDER_X 25
#define BORDER_Y 100


class Population
{
private:
	
public:
	int totalpop, totalchrome, elitismOffset,elitism;
	int oldpop, oldchrome;  // hack to make delete work
	int **Beings;
	int **Children;
	int **Tournament;

	int *child;
	int *parent1;
	int *parent2;

	double mutationRate;
	int gencounter;
	int Cursor;

	int deviceWidth, deviceHeight;

	HWND hwndEdit2;
	HWND hwndTitle;
	WCHAR sszText[MAX_LOADSTRING];  //temp will fix later

	Population(int, int,double,int);
	~Population();


	virtual void Init(int, int, TCHAR *);
	virtual void Draw(HDC,int *);
	virtual void Evolve();
	virtual int Fittest();
	virtual void CalcFitness();
	virtual int tournamentSelect();
	virtual int TournFittest();
	virtual void CalcOneFit(int,int);
	virtual void CrossOver(int *,int *);
	virtual void Mutate(int);
	virtual void CreateControls(HWND,ControlIT *);
	virtual void FreeStorage();
	virtual void Initial_Message();
	virtual void displaypopulation();
	virtual int fitnessLookup(int);



	// Some utilities
	virtual void copytoChild(int, int);
	virtual void copytoParent(int, int);
	virtual void arraycpy(int *, int *,int);
	virtual bool contains(int*, int, int);
	

};

